#ifndef ATOMINFO_H__
#define ATOMINFO_H__


/*
   CRC Handbook of Chemistry & Physics, 63rd edition, 1982-1983
   CRC Handbook of Chemistry & Physics, 70th edition, 1989-1990
 */


typedef struct
  {
    int         Z;
    const char  *Symbol;
    const char  *Name;
    float       Mass;
  }
  T_PSE;


#ifndef ATOMINFO_C__
extern
const T_PSE PSE[];
#else
const T_PSE PSE[] =
  {
    {   1, "H",  "hydrogen",       1.008 },
    {   1, "D",  "deuterium",      2.000 },
    {   2, "He", "helium",         4.003 },
    {   3, "Li", "lithium",        6.941 },
    {   4, "Be", "beryllium",      9.012 },
    {   5, "B",  "boron",         10.811 },
    {   6, "C",  "carbon",        12.011 },
    {   7, "N",  "nitrogen",      14.007 },
    {   8, "O",  "oxygen",        15.999 },
    {   9, "F",  "fluorine",      18.998 },
    {  10, "Ne", "neon",          20.180 },
    {  11, "Na", "sodium",        22.990 },
    {  12, "Mg", "magnesium",     24.305 },
    {  13, "Al", "aluminium",     26.982 },
    {  14, "Si", "silicon",       28.086 },
    {  15, "P",  "phosphorus",    30.974 },
    {  16, "S",  "sulphur",       32.066 },
    {  17, "Cl", "chlorine",      35.452 },
    {  18, "Ar", "argon",         39.948 },
    {  19, "K",  "potassium",     39.098 },
    {  20, "Ca", "calcium",       40.078 },
    {  21, "Sc", "scandium",      44.956 },
    {  22, "Ti", "titanium",      47.883 },
    {  23, "V",  "vanadium",      50.941 },
    {  24, "Cr", "chromium",      51.996 },
    {  25, "Mn", "manganese",     54.938 },
    {  26, "Fe", "iron",          55.847 },
    {  27, "Co", "cobalt",        58.933 },
    {  28, "Ni", "nickel",        58.691 },
    {  29, "Cu", "copper",        63.546 },
    {  30, "Zn", "zinc",          65.392 },
    {  31, "Ga", "gallium",       69.723 },
    {  32, "Ge", "germanium",     72.612 },
    {  33, "As", "arsenic",       74.922 },
    {  34, "Se", "selenium",      78.963 },
    {  35, "Br", "bromine",       79.904 },
    {  36, "Kr", "krypton",       83.801 },
    {  37, "Rb", "rubidium",      85.468 },
    {  38, "Sr", "strontium",     87.621 },
    {  39, "Y",  "yttrium",       88.906 },
    {  40, "Zr", "zirconium",     91.224 },
    {  41, "Nb", "niobium",       92.906 },
    {  42, "Mo", "molybdenum",    95.941 },
    {  43, "Tc", "technetium",    98.000 },
    {  44, "Ru", "ruthenium",    101.072 },
    {  45, "Rh", "rhodium",      102.905 },
    {  46, "Pd", "palladium",    106.421 },
    {  47, "Ag", "silver",       107.868 },
    {  48, "Cd", "cadmium",      112.411 },
    {  49, "In", "indium",       114.821 },
    {  50, "Sn", "tin",          118.710 },
    {  51, "Sb", "antimony",     121.753 },
    {  52, "Te", "tellurium",    127.603 },
    {  53, "I",  "iodine",       126.904 },
    {  54, "Xe", "xenon",        131.292 },
    {  55, "Cs", "caesium",      132.905 },
    {  56, "Ba", "barium",       137.327 },
    {  57, "La", "lanthanum",    138.906 },
    {  58, "Ce", "cerium",       140.115 },
    {  59, "Pr", "praseodymium", 140.908 },
    {  60, "Nd", "neodymium",    144.243 },
    {  61, "Pm", "promethium",   145.000 },
    {  62, "Sm", "samarium",     150.363 },
    {  63, "Eu", "europium",     151.965 },
    {  64, "Gd", "gadolinium",   157.253 },
    {  65, "Tb", "terbium",      158.925 },
    {  66, "Dy", "dysprosium",   162.503 },
    {  67, "Ho", "holmium",      164.930 },
    {  68, "Er", "erbium",       167.263 },
    {  69, "Tm", "thulium",      168.934 },
    {  70, "Yb", "ytterbium",    173.043 },
    {  71, "Lu", "lutetium",     174.967 },
    {  72, "Hf", "hafnium",      178.492 },
    {  73, "Ta", "tantalum",     180.948 },
    {  74, "W",  "tungsten",     183.853 },
    {  75, "Re", "rhenium",      186.207 },
    {  76, "Os", "osmium",       190.210 },
    {  77, "Ir", "iridium",      192.223 },
    {  78, "Pt", "platinum",     195.083 },
    {  79, "Au", "gold",         196.967 },
    {  80, "Hg", "mercury",      200.593 },
    {  81, "Tl", "thallium",     204.383 },
    {  82, "Pb", "lead",         207.210 },
    {  83, "Bi", "bismuth",      208.980 },
    {  84, "Po", "polonium",     209.000 },
    {  85, "At", "astatine",     210.000 },
    {  86, "Rn", "radon",        222.000 },
    {  87, "Fr", "francium",     223.000 },
    {  88, "Ra", "radium",       226.025 },
    {  89, "Ac", "actinium",     227.028 },
    {  90, "Th", "thorium",      232.038 },
    {  91, "Pa", "protactinium", 231.035 },
    {  92, "U",  "uranium",      238.028 },
    {  93, "Np", "neptunium",    237.048 },
    {  94, "Pu", "plutonium",    244.000 },
    {  95, "Am", "americium",    243.000 },
    {  96, "Cm", "curium",       247.000 },
    {  97, "Bk", "berkelium",    247.000 },
    {  98, "Cf", "californium",  251.000 },
    {  99, "Es", "einsteinium",  254.000 },
    { 100, "Fm", "fermium",      257.000 },
    { 101, "Md", "mendelevium",  258.000 },
    { 102, "No", "nobelium",     259.000 },
    { 103, "Lr", "lawrencium",   260.000 },
    {   0, NULL, NULL,             0.    }
  };
#endif /* ATOMINFO_C__ */


/*
    International Tables for Crystallography
      Volume C
      Mathematical, Physical and Chemical Tables
      Edited by A.J.C. Wilson
      Kluwer Academic Publishers
      Dordrecht/Boston/London
      1992

    Table 6.1.1.4 (pp. 500-502)
      Coefficients for analytical approximation to the scattering factors
      of Tables 6.1.1.1 and 6.1.1.3

    [ Table 6.1.1.4 is a reprint of Table 2.2B, pp. 99-101,
      International Tables for X-ray Crystallography, Volume IV,
      The Kynoch Press: Birmingham, England, 1974.
      There is just one difference, see "Tl3+".
    ]
 */


typedef struct
  {
    const char   *Label;
    float        a[4], b[4], c;
  }
  T_SF_IT92_CAA;


#ifndef ATOMINFO_C__
extern
const T_SF_IT92_CAA SF_IT92_CAA[];
#else
const T_SF_IT92_CAA SF_IT92_CAA[] =
  {
    { "H",     { 0.493002, 0.322912, 0.140191, 0.040810 },
               { 10.5109, 26.1257, 3.14236, 57.7997 },
               0.003038 },
    { "H'",    { 0.489918, 0.262003, 0.196767, 0.049879 },
               { 20.6593, 7.74039, 49.5519, 2.20159 },
               0.001305 },
               /* "'" added */
    { "D",     { 0.489918, 0.262003, 0.196767, 0.049879 },
               { 20.6593, 7.74039, 49.5519, 2.20159 },
               0.001305 },
               /* copy of "H'" */
    { "H1-",   { 0.897661, 0.565616, 0.415815, 0.116973 },
               { 53.1368, 15.1870, 186.576, 3.56709 },
               0.002389 },
    { "He",    { 0.873400, 0.630900, 0.311200, 0.178000 },
               { 9.10370, 3.35680, 22.9276, 0.982100 },
               0.006400 },
    { "Li",    { 1.12820, 0.750800, 0.617500, 0.465300 },
               { 3.95460, 1.05240, 85.3905, 168.261 },
               0.037700 },
    { "Li1+",  { 0.696800, 0.788800, 0.341400, 0.156300 },
               { 4.62370, 1.95570, 0.631600, 10.0953 },
               0.016700 },
    { "Be",    { 1.59190, 1.12780, 0.539100, 0.702900 },
               { 43.6427, 1.86230, 103.483, 0.542000 },
               0.038500 },
    { "Be2+",  { 6.26030, 0.884900, 0.799300, 0.164700 },
               { 0.002700, 0.831300, 2.27580, 5.11460 },
               -6.1092 },
    { "B",     { 2.05450, 1.33260, 1.09790, 0.706800 },
               { 23.2185, 1.02100, 60.3498, 0.140300 },
               -0.19320 },
    { "C",     { 2.31000, 1.02000, 1.58860, 0.865000 },
               { 20.8439, 10.2075, 0.568700, 51.6512 },
               0.215600 },
    { "Cval",  { 2.26069, 1.56165, 1.05075, 0.839259 },
               { 22.6907, 0.656665, 9.75618, 55.5949 },
               0.286977 },
    { "N",     { 12.2126, 3.13220, 2.01250, 1.16630 },
               { 0.005700, 9.89330, 28.9975, 0.582600 },
               -11.529 },
    { "O",     { 3.04850, 2.28680, 1.54630, 0.867000 },
               { 13.2771, 5.70110, 0.323900, 32.9089 },
               0.250800 },
    { "O1-",   { 4.19160, 1.63969, 1.52673, -20.307 },
               { 12.8573, 4.17236, 47.0179, -0.01404 },
               21.9412 },
    { "O2-",   { 3.75040, 2.84294, 1.54298, 1.62091 },
               { 16.5151, 6.59203, 0.319201, 43.3486 },
               0.242060 },
               /* Hovestreydt, Acta Cryst. (1983) A39, 268-269 */
    { "F",     { 3.53920, 2.64120, 1.51700, 1.02430 },
               { 10.2825, 4.29440, 0.261500, 26.1476 },
               0.277600 },
    { "F1-",   { 3.63220, 3.51057, 1.26064, 0.940706 },
               { 5.27756, 14.7353, 0.442258, 47.3437 },
               0.653396 },
    { "Ne",    { 3.95530, 3.11250, 1.45460, 1.12510 },
               { 8.40420, 3.42620, 0.230600, 21.7184 },
               0.351500 },
    { "Na",    { 4.76260, 3.17360, 1.26740, 1.11280 },
               { 3.28500, 8.84220, 0.313600, 129.424 },
               0.676000 },
    { "Na1+",  { 3.25650, 3.93620, 1.39980, 1.00320 },
               { 2.66710, 6.11530, 0.200100, 14.0390 },
               0.404000 },
    { "Mg",    { 5.42040, 2.17350, 1.22690, 2.30730 },
               { 2.82750, 79.2611, 0.380800, 7.19370 },
               0.858400 },
    { "Mg2+",  { 3.49880, 3.83780, 1.32840, 0.849700 },
               { 2.16760, 4.75420, 0.185000, 10.1411 },
               0.485300 },
    { "Al",    { 6.42020, 1.90020, 1.59360, 1.96460 },
               { 3.03870, 0.742600, 31.5472, 85.0886 },
               1.11510 },
    { "Al3+",  { 4.17448, 3.38760, 1.20296, 0.528137 },
               { 1.93816, 4.14553, 0.228753, 8.28524 },
               0.706786 },
    { "Si",    { 6.29150, 3.03530, 1.98910, 1.54100 },
               { 2.43860, 32.3337, 0.678500, 81.6937 },
               1.14070 },
               /* copy of "Siv" */
    { "Siv",   { 6.29150, 3.03530, 1.98910, 1.54100 },
               { 2.43860, 32.3337, 0.678500, 81.6937 },
               1.14070 },
    { "Sival", { 5.66269, 3.07164, 2.62446, 1.39320 },
               { 2.66520, 38.6634, 0.916946, 93.5458 },
               1.24707 },
    { "Si4+",  { 4.43918, 3.20345, 1.19453, 0.416530 },
               { 1.64167, 3.43757, 0.214900, 6.65365 },
               0.746297 },
    { "P",     { 6.43450, 4.17910, 1.78000, 1.49080 },
               { 1.90670, 27.1570, 0.526000, 68.1645 },
               1.11490 },
    { "S",     { 6.90530, 5.20340, 1.43790, 1.58630 },
               { 1.46790, 22.2151, 0.253600, 56.1720 },
               0.866900 },
    { "Cl",    { 11.4604, 7.19640, 6.25560, 1.64550 },
               { 0.010400, 1.16620, 18.5194, 47.7784 },
               -9.5574 },
    { "Cl1-",  { 18.2915, 7.20840, 6.53370, 2.33860 },
               { 0.006600, 1.17170, 19.5424, 60.4486 },
               -16.378 },
    { "Ar",    { 7.48450, 6.77230, 0.653900, 1.64420 },
               { 0.907200, 14.8407, 43.8983, 33.3929 },
               1.44450 },
    { "K",     { 8.21860, 7.43980, 1.05190, 0.865900 },
               { 12.7949, 0.774800, 213.187, 41.6841 },
               1.42280 },
    { "K1+",   { 7.95780, 7.49170, 6.35900, 1.19150 },
               { 12.6331, 0.767400, -0.00200, 31.9128 },
               -4.9978 },
    { "Ca",    { 8.62660, 7.38730, 1.58990, 1.02110 },
               { 10.4421, 0.659900, 85.7484, 178.437 },
               1.37510 },
    { "Ca2+",  { 15.6348, 7.95180, 8.43720, 0.853700 },
               { -0.00740, 0.608900, 10.3116, 25.9905 },
               -14.875 },
    { "Sc",    { 9.18900, 7.36790, 1.64090, 1.46800 },
               { 9.02130, 0.572900, 136.108, 51.3531 },
               1.33290 },
    { "Sc3+",  { 13.4008, 8.02730, 1.65943, 1.57936 },
               { 0.298540, 7.96290, -0.28604, 16.0662 },
               -6.6667 },
    { "Ti",    { 9.75950, 7.35580, 1.69910, 1.90210 },
               { 7.85080, 0.500000, 35.6338, 116.105 },
               1.28070 },
    { "Ti2+",  { 9.11423, 7.62174, 2.27930, 0.087899 },
               { 7.52430, 0.457585, 19.5361, 61.6558 },
               0.897155 },
    { "Ti3+",  { 17.7344, 8.73816, 5.25691, 1.92134 },
               { 0.220610, 7.04716, -0.15762, 15.9768 },
               -14.652 },
    { "Ti4+",  { 19.5114, 8.23473, 2.01341, 1.52080 },
               { 0.178847, 6.67018, -0.29263, 12.9464 },
               -13.280 },
    { "V",     { 10.2971, 7.35110, 2.07030, 2.05710 },
               { 6.86570, 0.438500, 26.8938, 102.478 },
               1.21990 },
    { "V2+",   { 10.1060, 7.35410, 2.28840, 0.022300 },
               { 6.88180, 0.440900, 20.3004, 115.122 },
               1.22980 },
    { "V3+",   { 9.43141, 7.74190, 2.15343, 0.016865 },
               { 6.39535, 0.383349, 15.1908, 63.9690 },
               0.656565 },
    { "V5+",   { 15.6887, 8.14208, 2.03081, -9.5760 },
               { 0.679003, 5.40135, 9.97278, 0.940464 },
               1.71430 },
    { "Cr",    { 10.6406, 7.35370, 3.32400, 1.49220 },
               { 6.10380, 0.392000, 20.2626, 98.7399 },
               1.18320 },
    { "Cr2+",  { 9.54034, 7.75090, 3.58274, 0.509107 },
               { 5.66078, 0.344261, 13.3075, 32.4224 },
               0.616898 },
    { "Cr3+",  { 9.68090, 7.81136, 2.87603, 0.113575 },
               { 5.59463, 0.334393, 12.8288, 32.8761 },
               0.518275 },
    { "Mn",    { 11.2819, 7.35730, 3.01930, 2.24410 },
               { 5.34090, 0.343200, 17.8674, 83.7543 },
               1.08960 },
    { "Mn2+",  { 10.8061, 7.36200, 3.52680, 0.218400 },
               { 5.27960, 0.343500, 14.3430, 41.3235 },
               1.08740 },
    { "Mn3+",  { 9.84521, 7.87194, 3.56531, 0.323613 },
               { 4.91797, 0.294393, 10.8171, 24.1281 },
               0.393974 },
    { "Mn4+",  { 9.96253, 7.97057, 2.76067, 0.054447 },
               { 4.84850, 0.283303, 10.4852, 27.5730 },
               0.251877 },
    { "Fe",    { 11.7695, 7.35730, 3.52220, 2.30450 },
               { 4.76110, 0.307200, 15.3535, 76.8805 },
               1.03690 },
    { "Fe2+",  { 11.0424, 7.37400, 4.13460, 0.439900 },
               { 4.65380, 0.305300, 12.0546, 31.2809 },
               1.00970 },
    { "Fe3+",  { 11.1764, 7.38630, 3.39480, 0.072400 },
               { 4.61470, 0.300500, 11.6729, 38.5566 },
               0.970700 },
    { "Co",    { 12.2841, 7.34090, 4.00340, 2.34880 },
               { 4.27910, 0.278400, 13.5359, 71.1692 },
               1.01180 },
    { "Co2+",  { 11.2296, 7.38830, 4.73930, 0.710800 },
               { 4.12310, 0.272600, 10.2443, 25.6466 },
               0.932400 },
    { "Co3+",  { 10.3380, 7.88173, 4.76795, 0.725591 },
               { 3.90969, 0.238668, 8.35583, 18.3491 },
               0.286667 },
    { "Ni",    { 12.8376, 7.29200, 4.44380, 2.38000 },
               { 3.87850, 0.256500, 12.1763, 66.3421 },
               1.03410 },
    { "Ni2+",  { 11.4166, 7.40050, 5.34420, 0.977300 },
               { 3.67660, 0.244900, 8.87300, 22.1626 },
               0.861400 },
    { "Ni3+",  { 10.7806, 7.75868, 5.22746, 0.847114 },
               { 3.54770, 0.223140, 7.64468, 16.9673 },
               0.386044 },
    { "Cu",    { 13.3380, 7.16760, 5.61580, 1.67350 },
               { 3.58280, 0.247000, 11.3966, 64.8126 },
               1.19100 },
    { "Cu1+",  { 11.9475, 7.35730, 6.24550, 1.55780 },
               { 3.36690, 0.227400, 8.66250, 25.8487 },
               0.89000 },
    { "Cu2+",  { 11.8168, 7.11181, 5.78135, 1.14523 },
               { 3.37484, 0.244078, 7.98760, 19.8970 },
               1.14431 },
    { "Zn",    { 14.0743, 7.03180, 5.16520, 2.41000 },
               { 3.26550, 0.233300, 10.3163, 58.7097 },
               1.30410 },
    { "Zn2+",  { 11.9719, 7.38620, 6.46680, 1.39400 },
               { 2.99460, 0.203100, 7.08260, 18.0995 },
               0.780700 },
    { "Ga",    { 15.2354, 6.70060, 4.35910, 2.96230 },
               { 3.06690, 0.241200, 10.7805, 61.4135 },
               1.71890 },
    { "Ga3+",  { 12.6920, 6.69883, 6.06692, 1.00660 },
               { 2.81262, 0.227890, 6.36441, 14.4122 },
               1.53545 },
    { "Ge",    { 16.0816, 6.37470, 3.70680, 3.68300 },
               { 2.85090, 0.251600, 11.4468, 54.7625 },
               2.13130 },
    { "Ge4+",  { 12.9172, 6.70003, 6.06791, 0.859041 },
               { 2.53718, 0.205855, 5.47913, 11.6030 },
               1.45572 },
    { "As",    { 16.6723, 6.07010, 3.43130, 4.27790 },
               { 2.63450, 0.264700, 12.9479, 47.7972 },
               2.53100 },
    { "Se",    { 17.0006, 5.81960, 3.97310, 4.35430 },
               { 2.40980, 0.272600, 15.2372, 43.8163 },
               2.84090 },
    { "Br",    { 17.1789, 5.23580, 5.63770, 3.98510 },
               { 2.17230, 16.5796, 0.260900, 41.4328 },
               2.95570 },
    { "Br1-",  { 17.1718, 6.33380, 5.57540, 3.72720 },
               { 2.20590, 19.3345, 0.287100, 58.1535 },
               3.17760 },
    { "Kr",    { 17.3555, 6.72860, 5.54930, 3.53750 },
               { 1.93840, 16.5623, 0.226100, 39.3972 },
               2.82500 },
    { "Rb",    { 17.1784, 9.64350, 5.13990, 1.52920 },
               { 1.78880, 17.3151, 0.274800, 164.934 },
               3.48730 },
    { "Rb1+",  { 17.5816, 7.65980, 5.89810, 2.78170 },
               { 1.71390, 14.7957, 0.160300, 31.2087 },
               2.07820 },
    { "Sr",    { 17.5663, 9.81840, 5.42200, 2.66940 },
               { 1.55640, 14.0988, 0.166400, 132.376 },
               2.50640 },
    { "Sr2+",  { 18.0874, 8.13730, 2.56540, -34.193 },
               { 1.49070, 12.6963, 24.5651, -0.01380 },
               41.4025 },
    { "Y",     { 17.7760, 10.2946, 5.72629, 3.26588 },
               { 1.40290, 12.8006, 0.125599, 104.354 },
               1.91213 },
    { "Y3+",   { 17.9268, 9.15310, 1.76795, -33.108 },
               { 1.35417, 11.2145, 22.6599, -0.01319 },
               40.2602 },
    { "Zr",    { 17.8765, 10.9480, 5.41732, 3.65721 },
               { 1.27618, 11.9160, 0.117622, 87.6627 },
               2.06929 },
    { "Zr4+",  { 18.1668, 10.0562, 1.01118, -2.6479 },
               { 1.21480, 10.1483, 21.6054, -0.10276 },
               9.41454 },
    { "Nb",    { 17.6142, 12.0144, 4.04183, 3.53346 },
               { 1.18865, 11.7660, 0.204785, 69.7957 },
               3.75591 },
    { "Nb3+",  { 19.8812, 18.0653, 11.0177, 1.94715 },
               { 0.019175, 1.13305, 10.1621, 28.3389 },
               -12.912 },
    { "Nb5+",  { 17.9163, 13.3417, 10.7990, 0.337905 },
               { 1.12446, 0.028781, 9.28206, 25.7228 },
               -6.3934 },
    { "Mo",    { 3.70250, 17.2356, 12.8876, 3.74290 },
               { 0.277200, 1.09580, 11.0040, 61.6584 },
               4.38750 },
    { "Mo3+",  { 21.1664, 18.2017, 11.7423, 2.30951 },
               { 0.014734, 1.03031, 9.53659, 26.6307 },
               -14.421 },
    { "Mo5+",  { 21.0149, 18.0992, 11.4632, 0.740625 },
               { 0.014345, 1.02238, 8.78809, 23.3452 },
               -14.316 },
    { "Mo6+",  { 17.8871, 11.1750, 6.57891, 0.000000 },
               { 1.03649, 8.48061, 0.058881, 0.000000 },
               0.344941 },
    { "Tc",    { 19.1301, 11.0948, 4.64901, 2.71263 },
               { 0.864132, 8.14487, 21.5707, 86.8472 },
               5.40428 },
    { "Ru",    { 19.2674, 12.9182, 4.86337, 1.56756 },
               { 0.808520, 8.43467, 24.7997, 94.2928 },
               5.37874 },
    { "Ru3+",  { 18.5638, 13.2885, 9.32602, 3.00964 },
               { 0.847329, 8.37164, 0.017662, 22.8870 },
               -3.1892 },
    { "Ru4+",  { 18.5003, 13.1787, 4.71304, 2.18535 },
               { 0.844582, 8.12534, 0.36495, 20.8504 },
               1.42357 },
    { "Rh",    { 19.2957, 14.3501, 4.73425, 1.28918 },
               { 0.751536, 8.21758, 25.8749, 98.6062 },
               5.32800 },
    { "Rh3+",  { 18.8785, 14.1259, 3.32515, -6.1989 },
               { 0.764252, 7.84438, 21.2487, -0.01036 },
               11.8678 },
    { "Rh4+",  { 18.8545, 13.9806, 2.53464, -5.6526 },
               { 0.760825, 7.62436, 19.3317, -0.01020 },
               11.2835 },
    { "Pd",    { 19.3319, 15.5017, 5.29537, 0.605844 },
               { 0.698655, 7.98929, 25.2052, 76.8986 },
               5.26593 },
    { "Pd2+",  { 19.1701, 15.2096, 4.32234, 0.000000 },
               { 0.696219, 7.55573, 22.5057, 0.000000 },
               5.29160 },
    { "Pd4+",  { 19.2493, 14.7900, 2.89289, -7.9492 },
               { 0.683839, 7.14833, 17.9144, 0.005127 },
               13.0174 },
    { "Ag",    { 19.2808, 16.6885, 4.80450, 1.04630 },
               { 0.644600, 7.47260, 24.6605, 99.8156 },
               5.17900 },
    { "Ag1+",  { 19.1812, 15.9719, 5.27475, 0.357534 },
               { 0.646179, 7.19123, 21.7326, 66.1147 },
               5.21572 },
    { "Ag2+",  { 19.1643, 16.2456, 4.37090, 0.000000 },
               { 0.645643, 7.18544, 21.4072, 0.000000 },
               5.21404 },
    { "Cd",    { 19.2214, 17.6444, 4.46100, 1.60290 },
               { 0.594600, 6.90890, 24.7008, 87.4825 },
               5.06940 },
    { "Cd2+",  { 19.1514, 17.2535, 4.47128, 0.000000 },
               { 0.597922, 6.80639, 20.2521, 0.000000 },
               5.11937 },
    { "In",    { 19.1624, 18.5596, 4.29480, 2.03960 },
               { 0.547600, 6.37760, 25.8499, 92.8029 },
               4.93910 },
    { "In3+",  { 19.1045, 18.1108, 3.78897, 0.000000 },
               { 0.551522, 6.32470, 17.3595, 0.000000 },
               4.99635 },
    { "Sn",    { 19.1889, 19.1005, 4.45850, 2.46630 },
               { 5.83030, 0.503100, 26.8909, 83.9571 },
               4.78210 },
    { "Sn2+",  { 19.1094, 19.0548, 4.56480, 0.487000 },
               { 0.503600, 5.83780, 23.3752, 62.2061 },
               4.78610 },
    { "Sn4+",  { 18.9333, 19.7131, 3.41820, 0.019300 },
               { 5.76400, 0.465500, 14.0049, -0.75830 },
               3.91820 },
    { "Sb",    { 19.6418, 19.0455, 5.03710, 2.68270 },
               { 5.30340, 0.460700, 27.9074, 75.2825 },
               4.59090 },
    { "Sb3+",  { 18.9755, 18.9330, 5.10789, 0.288753 },
               { 0.467196, 5.22126, 19.5902, 55.5113 },
               4.69626 },
    { "Sb5+",  { 19.8685, 19.0302, 2.41253, 0.000000 },
               { 5.44853, 0.467973, 14.1259, 0.000000 },
               4.69263 },
    { "Te",    { 19.9644, 19.0138, 6.14487, 2.52390 },
               { 4.81742, 0.420885, 28.5284, 70.8403 },
               4.35200 },
    { "I",     { 20.1472, 18.9949, 7.51380, 2.27350 },
               { 4.34700, 0.381400, 27.7660, 66.8776 },
               4.07120 },
    { "I1-",   { 20.2332, 18.9970, 7.80690, 2.88680 },
               { 4.35790, 0.381500, 29.5259, 84.9304 },
               4.07140 },
    { "Xe",    { 20.2933, 19.0298, 8.97670, 1.99000 },
               { 3.92820, 0.344000, 26.4659, 64.2658 },
               3.71180 },
    { "Cs",    { 20.3892, 19.1062, 10.6620, 1.49530 },
               { 3.56900, 0.310700, 24.3879, 213.904 },
               3.33520 },
    { "Cs1+",  { 20.3524, 19.1278, 10.2821, 0.961500 },
               { 3.55200, 0.308600, 23.7128, 59.4565 },
               3.27910 },
    { "Ba",    { 20.3361, 19.2970, 10.8880, 2.69590 },
               { 3.21600, 0.275600, 20.2073, 167.202 },
               2.77310 },
    { "Ba2+",  { 20.1807, 19.1136, 10.9054, 0.77634 },
               { 3.21367, 0.283310, 20.0558, 51.7460 },
               3.02902 },
    { "La",    { 20.5780, 19.5990, 11.3727, 3.28719 },
               { 2.94817, 0.244475, 18.7726, 133.124 },
               2.14678 },
    { "La3+",  { 20.2489, 19.3763, 11.6323, 0.336048 },
               { 2.92070, 0.250698, 17.8211, 54.9453 },
               2.40860 },
    { "Ce",    { 21.1671, 19.7695, 11.8513, 3.33049 },
               { 2.81219, 0.226836, 17.6083, 127.113 },
               1.86264 },
    { "Ce3+",  { 20.8036, 19.5590, 11.9369, 0.612376 },
               { 2.77691, 0.231540, 16.5408, 43.1692 },
               2.09013 },
    { "Ce4+",  { 20.3235, 19.8186, 12.1233, 0.144583 },
               { 2.65941, 0.218850, 15.7992, 62.2355 },
               1.59180 },
    { "Pr",    { 22.0440, 19.6697, 12.3856, 2.82428 },
               { 2.77393, 0.222087, 16.7669, 143.644 },
               2.05830 },
    { "Pr3+",  { 21.3727, 19.7491, 12.1329, 0.975180 },
               { 2.64520, 0.214299, 15.3230, 36.4065 },
               1.77132 },
    { "Pr4+",  { 20.9413, 20.0539, 12.4668, 0.296689 },
               { 2.54467, 0.202481, 14.8137, 45.4643 },
               1.24285 },
    { "Nd",    { 22.6845, 19.6847, 12.7740, 2.85137 },
               { 2.66248, 0.210628, 15.8850, 137.903 },
               1.98486 },
    { "Nd3+",  { 21.9610, 19.9339, 12.1200, 1.51031 },
               { 2.52722, 0.199237, 14.1783, 30.8717 },
               1.47588 },
    { "Pm",    { 23.3405, 19.6095, 13.1235, 2.87516 },
               { 2.56270, 0.202088, 15.1009, 132.721 },
               2.02876 },
    { "Pm3+",  { 22.5527, 20.1108, 12.0671, 2.07492 },
               { 2.41740, 0.185769, 13.1275, 27.4491 },
               1.19499 },
    { "Sm",    { 24.0042, 19.4258, 13.4396, 2.89604 },
               { 2.47274, 0.196451, 14.3996, 128.007 },
               2.20963 },
    { "Sm3+",  { 23.1504, 20.2599, 11.9202, 2.71488 },
               { 2.31641, 0.174081, 12.1571, 24.8242 },
               0.954586 },
    { "Eu",    { 24.6274, 19.0886, 13.7603, 2.92270 },
               { 2.38790, 0.194200, 13.7546, 123.174 },
               2.57450 },
    { "Eu2+",  { 24.0063, 19.9504, 11.8034, 3.87243 },
               { 2.27783, 0.173530, 11.6096, 26.5156 },
               1.36389 },
    { "Eu3+",  { 23.7497, 20.3745, 11.8509, 3.26503 },
               { 2.22258, 0.163940, 11.3110, 22.9966 },
               0.759344 },
    { "Gd",    { 25.0709, 19.0798, 13.8518, 3.54545 },
               { 2.25341, 0.181951, 12.9331, 101.398 },
               2.41960 },
    { "Gd3+",  { 24.3466, 20.4208, 11.8708, 3.71490 },
               { 2.13553, 0.155525, 10.5782, 21.7029 },
               0.645089 },
    { "Tb",    { 25.8976, 18.2185, 14.3167, 2.95354 },
               { 2.24256, 0.196143, 12.6648, 115.362 },
               3.58324 },
    { "Tb3+",  { 24.9559, 20.3271, 12.2471, 3.77300 },
               { 2.05601, 0.149525, 10.0499, 21.2773 },
               0.691967 },
    { "Dy",    { 26.5070, 17.6383, 14.5596, 2.96577 },
               { 2.18020, 0.202172, 12.1899, 111.874 },
               4.29728 },
    { "Dy3+",  { 25.5395, 20.2861, 11.9812, 4.50073 },
               { 1.98040, 0.143384, 9.34972, 19.5810 },
               0.689690 },
    { "Ho",    { 26.9049, 17.2940, 14.5583, 3.63837 },
               { 2.07051, 0.197940, 11.4407, 92.6566 },
               4.56796 },
    { "Ho3+",  { 26.1296, 20.0994, 11.9788, 4.93676 },
               { 1.91072, 0.139358, 8.80018, 18.5908 },
               0.852795 },
    { "Er",    { 27.6563, 16.4285, 14.9779, 2.98233 },
               { 2.07356, 0.223545, 11.3604, 105.703 },
               5.92046 },
    { "Er3+",  { 26.7220, 19.7748, 12.1506, 5.17379 },
               { 1.84659, 0.137290, 8.36225, 17.8974 },
               1.17613 },
    { "Tm",    { 28.1819, 15.8851, 15.1542, 2.98706 },
               { 2.02859, 0.238849, 10.9975, 102.961 },
               6.75621 },
    { "Tm3+",  { 27.3083, 19.3320, 12.3339, 5.38348 },
               { 1.78711, 0.136974, 7.96778, 17.2922 },
               1.63929 },
    { "Yb",    { 28.6641, 15.4345, 15.3087, 2.98963 },
               { 1.98890, 0.257119, 10.6647, 100.417 },
               7.56672 },
    { "Yb2+",  { 28.1209, 17.6817, 13.3335, 5.14657 },
               { 1.78503, 0.159970, 8.18304, 20.3900 },
               3.70983 },
    { "Yb3+",  { 27.8917, 18.7614, 12.6072, 5.47647 },
               { 1.73272, 0.138790, 7.64412, 16.8153 },
               2.26001 },
    { "Lu",    { 28.9476, 15.2208, 15.1000, 3.71601 },
               { 1.90182, 9.98519, 0.261033, 84.3298 },
               7.97628 },
    { "Lu3+",  { 28.4628, 18.1210, 12.8429, 5.59415 },
               { 1.68216, 0.142292, 7.33727, 16.3535 },
               2.97573 },
    { "Hf",    { 29.1440, 15.1726, 14.7586, 4.30013 },
               { 1.83262, 9.59990, 0.275116, 72.0290 },
               8.58154 },
    { "Hf4+",  { 28.8131, 18.4601, 12.7285, 5.59927 },
               { 1.59136, 0.128903, 6.76232, 14.0366 },
               2.39699 },
    { "Ta",    { 29.2024, 15.2293, 14.5135, 4.76492 },
               { 1.77333, 9.37046, 0.295977, 63.3644 },
               9.24354 },
    { "Ta5+",  { 29.1587, 18.8407, 12.8268, 5.38695 },
               { 1.50711, 0.116741, 6.31524, 12.4244 },
               1.78555 },
    { "W",     { 29.0818, 15.4300, 14.4327, 5.11982 },
               { 1.72029, 9.22590, 0.321703, 57.0560 },
               9.88750 },
    { "W6+",   { 29.4936, 19.3763, 13.0544, 5.06412 },
               { 1.42755, 0.104621, 5.93667, 11.1972 },
               1.01074 },
    { "Re",    { 28.7621, 15.7189, 14.5564, 5.44174 },
               { 1.67191, 9.09227, 0.350500, 52.0861 },
               10.4720 },
    { "Os",    { 28.1894, 16.1550, 14.9305, 5.67589 },
               { 1.62903, 8.97948, 0.382661, 48.1647 },
               11.0005 },
    { "Os4+",  { 30.4190, 15.2637, 14.7458, 5.06795 },
               { 1.37113, 6.84706, 0.165191, 18.0030 },
               6.49804 },
    { "Ir",    { 27.3049, 16.7296, 15.6115, 5.83377 },
               { 1.59279, 8.86553, 0.417916, 45.0011 },
               11.4722 },
    { "Ir3+",  { 30.4156, 15.8620, 13.6145, 5.82008 },
               { 1.34323, 7.10909, 0.204633, 20.3254 },
               8.27903 },
    { "Ir4+",  { 30.7058, 15.5512, 14.2326, 5.53672 },
               { 1.30923, 6.71983, 0.167252, 17.4911 },
               6.96824 },
    { "Pt",    { 27.0059, 17.7639, 15.7131, 5.78370 },
               { 1.51293, 8.81174, 0.424593, 38.6103 },
               11.6883 },
    { "Pt2+",  { 29.8429, 16.7224, 13.2153, 6.35234 },
               { 1.32927, 7.38979, 0.263297, 22.9426 },
               9.85329 },
    { "Pt4+",  { 30.9612, 15.9829, 13.7348, 5.92034 },
               { 1.24813, 6.60834, 0.168640, 16.9392 },
               7.39534 },
    { "Au",    { 16.8819, 18.5913, 25.5582, 5.86000 },
               { 0.461100, 8.62160, 1.48260, 36.3956 },
               12.0658 },
    { "Au1+",  { 28.0109, 17.8204, 14.3359, 6.58077 },
               { 1.35321, 7.73950, 0.356752, 26.4043 },
               11.2299 },
    { "Au3+",  { 30.6886, 16.9029, 12.7801, 6.52354 },
               { 1.21990, 6.82872, 0.212867, 18.6590 },
               9.09680 },
    { "Hg",    { 20.6809, 19.0417, 21.6575, 5.96760 },
               { 0.545000, 8.44840, 1.57290, 38.3246 },
               12.6089 },
    { "Hg1+",  { 25.0853, 18.4973, 16.8883, 6.48216 },
               { 1.39507, 7.65105, 0.443378, 28.2262 },
               12.0205 },
    { "Hg2+",  { 29.5641, 18.0600, 12.8374, 6.89912 },
               { 1.21152, 7.05639, 0.284738, 20.7482 },
               10.6268 },
    { "Tl",    { 27.5446, 19.1584, 15.5380, 5.52593 },
               { 0.655150, 8.70751, 1.96347, 45.8149 },
               13.1746 },
    { "Tl1+",  { 21.3985, 20.4723, 18.7478, 6.82847 },
               { 1.47110, 0.517394, 7.43463, 28.8482 },
               12.5258 },
    { "Tl3+",  { 30.8695, 18.3841, 11.9328, 7.00574 },
               { 1.10080, 6.53852, 0.219074, 17.2114 },
               9.80270 },
               /* IT Vol IV 1974: a2 = 18.3841
                  IT Vol C  1992: a2 = 18.3481 */
    { "Pb",    { 31.0617, 13.0637, 18.4420, 5.96960 },
               { 0.690200, 2.35760, 8.61800, 47.2579 },
               13.4118 },
    { "Pb2+",  { 21.7886, 19.5682, 19.1406, 7.01107 },
               { 1.33660, 0.488383, 6.77270, 23.8132 },
               12.4734 },
    { "Pb4+",  { 32.1244, 18.8003, 12.0175, 6.96886 },
               { 1.00566, 6.10926, 0.147041, 14.7140 },
               8.08428 },
    { "Bi",    { 33.3689, 12.9510, 16.5877, 6.46920 },
               { 0.704000, 2.92380, 8.79370, 48.0093 },
               13.5782 },
    { "Bi3+",  { 21.8053, 19.5026, 19.1053, 7.10295 },
               { 1.23560, 6.24149, 0.469999, 20.3185 },
               12.4711 },
    { "Bi5+",  { 33.5364, 25.0946, 19.2497, 6.91555 },
               { 0.916540, 0.39042, 5.71414, 12.8285 },
               -6.7994 },
    { "Po",    { 34.6726, 15.4733, 13.1138, 7.02588 },
               { 0.700999, 3.55078, 9.55642, 47.0045 },
               13.6770 },
    { "At",    { 35.3163, 19.0211, 9.49887, 7.42518 },
               { 0.685870, 3.97458, 11.3824, 45.4715 },
               13.7108 },
    { "Rn",    { 35.5631, 21.2816, 8.00370, 7.44330 },
               { 0.663100, 4.06910, 14.0422, 44.2473 },
               13.6905 },
    { "Fr",    { 35.9299, 23.0547, 12.1439, 2.11253 },
               { 0.646453, 4.17619, 23.1052, 150.645 },
               13.7247 },
    { "Ra",    { 35.7630, 22.9064, 12.4739, 3.21097 },
               { 0.616341, 3.87135, 19.9887, 142.325 },
               13.6211 },
    { "Ra2+",  { 35.2150, 21.6700, 7.91342, 7.65078 },
               { 0.604909, 3.57670, 12.6010, 29.8436 },
               13.5431 },
    { "Ac",    { 35.6597, 23.1032, 12.5977, 4.08655 },
               { 0.589092, 3.65155, 18.5990, 117.020 },
               13.5266 },
    { "Ac3+",  { 35.1736, 22.1112, 8.19216, 7.05545 },
               { 0.579689, 3.41437, 12.9187, 25.9443 },
               13.4637 },
    { "Th",    { 35.5645, 23.4219, 12.7473, 4.80703 },
               { 0.563359, 3.46204, 17.8309, 99.1722 },
               13.4314 },
    { "Th4+",  { 35.1007, 22.4418, 9.78554, 5.29444 },
               { 0.555054, 3.24498, 13.4661, 23.9533 },
               13.3760 },
    { "Pa",    { 35.8847, 23.2948, 14.1891, 4.17287 },
               { 0.547751, 3.41519, 16.9235, 105.251 },
               13.4287 },
    { "U",     { 36.0228, 23.4128, 14.9491, 4.18800 },
               { 0.529300, 3.32530, 16.0927, 100.613 },
               13.3966 },
    { "U3+",   { 35.5747, 22.5259, 12.2165, 5.37073 },
               { 0.520480, 3.12293, 12.7148, 26.3394 },
               13.3092 },
    { "U4+",   { 35.3715, 22.5326, 12.0291, 4.79840 },
               { 0.516598, 3.05053, 12.5723, 23.4582 },
               13.2671 },
    { "U6+",   { 34.8509, 22.7584, 14.0099, 1.21457 },
               { 0.507079, 2.89030, 13.1767, 25.2017 },
               13.1665 },
    { "Np",    { 36.1874, 23.5964, 15.6402, 4.18550 },
               { 0.511929, 3.25396, 15.3622, 97.4908 },
               13.3573 },
    { "Np3+",  { 35.7074, 22.6130, 12.9898, 5.43227 },
               { 0.502322, 3.03807, 12.1449, 25.4928 },
               13.2544 },
    { "Np4+",  { 35.5103, 22.5787, 12.7766, 4.92159 },
               { 0.498626, 2.96627, 11.9484, 22.7502 },
               13.2116 },
    { "Np6+",  { 35.0136, 22.7286, 14.3884, 1.75669 },
               { 0.489810, 2.81099, 12.3300, 22.6581 },
               13.1130 },
    { "Pu",    { 36.5254, 23.8083, 16.7707, 3.47947 },
               { 0.499384, 3.26371, 14.9455, 105.980 },
               13.3812 },
    { "Pu3+",  { 35.8400, 22.7169, 13.5807, 5.66016 },
               { 0.484938, 2.96118, 11.5331, 24.3992 },
               13.1991 },
    { "Pu4+",  { 35.6493, 22.6460, 13.3595, 5.18831 },
               { 0.481422, 2.89020, 11.3160, 21.8301 },
               13.1555 },
    { "Pu6+",  { 35.1736, 22.7181, 14.7635, 2.28678 },
               { 0.473204, 2.73848, 11.5530, 20.9303 },
               13.0582 },
    { "Am",    { 36.6706, 24.0992, 17.3415, 3.49331 },
               { 0.483629, 3.20647, 14.3136, 102.273 },
               13.3592 },
    { "Cm",    { 36.6488, 24.4096, 17.3990, 4.21665 },
               { 0.465154, 3.08997, 13.4346, 88.4834 },
               13.2887 },
    { "Bk",    { 36.7881, 24.7736, 17.8919, 4.23284 },
               { 0.451018, 3.04619, 12.8946, 86.0030 },
               13.2754 },
    { "Cf",    { 36.9185, 25.1995, 18.3317, 4.24391 },
               { 0.437533, 3.00775, 12.4044, 83.7881 },
               13.2674 },
    { "Es",    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. },
    { "Fm",    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. },
    { "Md",    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. },
    { "No",    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. },
    { "Lr",    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. },
    { NULL,    { 0., 0., 0., 0. },
               { 0., 0., 0., 0. },
               0. }
  };
#endif /* ATOMINFO_C__ */


/*
  SF_WK95_CAA contains the reformatted data found in

      ftp://wrzx02.rz.uni-wuerzburg.de/pub/local/Crystallography/sfac.dat

  File picked up Jul  4, 1995.
  File verified  Jun 11, 1996.

  Head of "index.txt" in same directory:

    New Analytical Scattering Factor Functions for Free Atoms and Ions
                        D. Waasmaier & A. Kirfel
                     Acta Cryst. A, 1995, in press
                              April, 1995

  Header of "sfac.dat":

    - Fitparameters of all atoms/ions (with the excepetion of O1-)
      from publication "New Analytical Scattering Factor Functions
      for Free Atoms and Ions", D. Waasmaier & A. Kirfel, Acta Cryst.
      A 1995, in press)

    - Fit for O1- based on the tabulated values of Table 2 (D.REZ,
      P.REZ & I.GRANT, Acta Cryst. (1994), A50, 481-497).

    - Fits for all other atoms/ions based on the tabulated values
      of Table 6.1.1.1 (atoms) and Table 6.1.1.3 (ions)
      (International Tables for Crystallography, Vol. C, 1992).

  Current Contents:
    WAASMAIER D; KIRFEL A.
    NEW ANALYTICAL SCATTERING-FACTOR FUNCTIONS FOR FREE ATOMS AND IONS.
    ACTA CRYSTALLOGRAPHICA SECTION A, 1995 MAY 1, V51 MAY:416-431.
 */


typedef struct
  {
    const char   *Label;
    float        a[5], b[5], c;
  }
  T_SF_WK95_CAA;


#ifndef ATOMINFO_C__
extern
const T_SF_WK95_CAA SF_WK95_CAA[];
#else
const T_SF_WK95_CAA SF_WK95_CAA[] =
  {
    { "H",     { 0.413048, 0.294953, 0.187491, 0.080701, 0.023736 },
               { 15.569946, 32.398468, 5.711404, 61.889874, 1.334118 },
               0.000049 },
    { "D",     { 0.413048, 0.294953, 0.187491, 0.080701, 0.023736 },
               { 15.569946, 32.398468, 5.711404, 61.889874, 1.334118 },
               0.000049 },
               /* copy of "H" */
    { "He",    { 0.732354, 0.753896, 0.283819, 0.190003, 0.039139 },
               { 11.553918, 4.595831, 1.546299, 26.463964, 0.377523 },
               0.000487 },
    { "Li",    { 0.974637, 0.158472, 0.811855, 0.262416, 0.790108 },
               { 4.334946, 0.342451, 97.102966, 201.363831, 1.409234 },
               0.002542 },
    { "Be",    { 1.533712, 0.638283, 0.601052, 0.106139, 1.118414 },
               { 42.662079, 0.595420, 99.106499, 0.151340, 1.843093 },
               0.002511 },
    { "B",     { 2.085185, 1.064580, 1.062788, 0.140515, 0.641784 },
               { 23.494068, 1.137894, 61.238976, 0.114886, 0.399036 },
               0.003823 },
    { "C",     { 2.657506, 1.078079, 1.490909, -4.241070, 0.713791 },
               { 14.780758, 0.776775, 42.086842, -0.000294, 0.239535 },
               4.297983 },
    { "N",     { 11.893780, 3.277479, 1.858092, 0.858927, 0.912985 },
               { 0.000158, 10.232723, 30.344690, 0.656065, 0.217287 },
               -11.804902 },
    { "O",     { 2.960427, 2.508818, 0.637853, 0.722838, 1.142756 },
               { 14.182259, 5.936858, 0.112726, 34.958481, 0.390240 },
               0.027014 },
    { "F",     { 3.511943, 2.772244, 0.678385, 0.915159, 1.089261 },
               { 10.687859, 4.380466, 0.093982, 27.255203, 0.313066 },
               0.032557 },
    { "Ne",    { 4.183749, 2.905726, 0.520513, 1.135641, 1.228065 },
               { 8.175457, 3.252536, 0.063295, 21.813910, 0.224952 },
               0.025576 },
    { "Na",    { 4.910127, 3.081783, 1.262067, 1.098938, 0.560991 },
               { 3.281434, 9.119178, 0.102763, 132.013947, 0.405878 },
               0.079712 },
    { "Mg",    { 4.708971, 1.194814, 1.558157, 1.170413, 3.239403 },
               { 4.875207, 108.506081, 0.111516, 48.292408, 1.928171 },
               0.126842 },
    { "Al",    { 4.730796, 2.313951, 1.541980, 1.117564, 3.154754 },
               { 3.628931, 43.051167, 0.095960, 108.932388, 1.555918 },
               0.139509 },
    { "Si",    { 5.275329, 3.191038, 1.511514, 1.356849, 2.519114 },
               { 2.631338, 33.730728, 0.081119, 86.288643, 1.170087 },
               0.145073 },
    { "P",     { 1.950541, 4.146930, 1.494560, 1.522042, 5.729711 },
               { 0.908139, 27.044952, 0.071280, 67.520187, 1.981173 },
               0.155233 },
    { "S",     { 6.372157, 5.154568, 1.473732, 1.635073, 1.209372 },
               { 1.514347, 22.092527, 0.061373, 55.445175, 0.646925 },
               0.154722 },
    { "Cl",    { 1.446071, 6.870609, 6.151801, 1.750347, 0.634168 },
               { 0.052357, 1.193165, 18.343416, 46.398396, 0.401005 },
               0.146773 },
    { "Ar",    { 7.188004, 6.638454, 0.454180, 1.929593, 1.523654 },
               { 0.956221, 15.339877, 15.339862, 39.043823, 0.062409 },
               0.265954 },
    { "K",     { 8.163991, 7.146945, 1.070140, 0.877316, 1.486434 },
               { 12.816323, 0.808945, 210.327011, 39.597652, 0.052821 },
               0.253614 },
    { "Ca",    { 8.593655, 1.477324, 1.436254, 1.182839, 7.113258 },
               { 10.460644, 0.041891, 81.390381, 169.847839, 0.688098 },
               0.196255 },
    { "Sc",    { 1.476566, 1.487278, 1.600187, 9.177463, 7.099750 },
               { 53.131023, 0.035325, 137.319489, 9.098031, 0.602102 },
               0.157765 },
    { "Ti",    { 9.818524, 1.522646, 1.703101, 1.768774, 7.082555 },
               { 8.001879, 0.029763, 39.885422, 120.157997, 0.532405 },
               0.102473 },
    { "V",     { 10.473575, 1.547881, 1.986381, 1.865616, 7.056250 },
               { 7.081940, 0.026040, 31.909672, 108.022842, 0.474882 },
               0.067744 },
    { "Cr",    { 11.007069, 1.555477, 2.985293, 1.347855, 7.034779 },
               { 6.366281, 0.023987, 23.244839, 105.774498, 0.429369 },
               0.065510 },
    { "Mn",    { 11.709542, 1.733414, 2.673141, 2.023368, 7.003180 },
               { 5.597120, 0.017800, 21.788420, 89.517914, 0.383054 },
               -0.147293 },
    { "Fe",    { 12.311098, 1.876623, 3.066177, 2.070451, 6.975185 },
               { 5.009415, 0.014461, 18.743040, 82.767876, 0.346506 },
               -0.304931 },
    { "Co",    { 12.914510, 2.481908, 3.466894, 2.106351, 6.960892 },
               { 4.507138, 0.009126, 16.438129, 76.987320, 0.314418 },
               -0.936572 },
    { "Ni",    { 13.521865, 6.947285, 3.866028, 2.135900, 4.284731 },
               { 4.077277, 0.286763, 14.622634, 71.966080, 0.004437 },
               -2.762697 },
    { "Cu",    { 14.014192, 4.784577, 5.056806, 1.457971, 6.932996 },
               { 3.738280, 0.003744, 13.034982, 72.554794, 0.265666 },
               -3.254477 },
    { "Zn",    { 14.741002, 6.907748, 4.642337, 2.191766, 38.424042 },
               { 3.388232, 0.243315, 11.903689, 63.312130, 0.000397 },
               -36.915829 },
    { "Ga",    { 15.758946, 6.841123, 4.121016, 2.714681, 2.395246 },
               { 3.121754, 0.226057, 12.482196, 66.203621, 0.007238 },
               -0.847395 },
    { "Ge",    { 16.540613, 1.567900, 3.727829, 3.345098, 6.785079 },
               { 2.866618, 0.012198, 13.432163, 58.866047, 0.210974 },
               0.018726 },
    { "As",    { 17.025642, 4.503441, 3.715904, 3.937200, 6.790175 },
               { 2.597739, 0.003012, 14.272119, 50.437996, 0.193015 },
               -2.984117 },
    { "Se",    { 17.354071, 4.653248, 4.259489, 4.136455, 6.749163 },
               { 2.349787, 0.002550, 15.579460, 45.181202, 0.177432 },
               -3.160982 },
    { "Br",    { 17.550570, 5.411882, 3.937180, 3.880645, 6.707793 },
               { 2.119226, 16.557184, 0.002481, 42.164009, 0.162121 },
               -2.492088 },
    { "Kr",    { 17.655279, 6.848105, 4.171004, 3.446760, 6.685200 },
               { 1.908231, 16.606236, 0.001598, 39.917473, 0.146896 },
               -2.810592 },
    { "Rb",    { 8.123134, 2.138042, 6.761702, 1.156051, 17.679546 },
               { 15.142385, 33.542667, 0.129372, 224.132507, 1.713368 },
               1.139548 },
    { "Sr",    { 17.730219, 9.795867, 6.099763, 2.620025, 0.600053 },
               { 1.563060, 14.310868, 0.120574, 135.771317, 0.120574 },
               1.140251 },
    { "Y",     { 17.792040, 10.253252, 5.714949, 3.170516, 0.918251 },
               { 1.429691, 13.132816, 0.112173, 108.197029, 0.112173 },
               1.131787 },
    { "Zr",    { 17.859772, 10.911038, 5.821115, 3.512513, 0.746965 },
               { 1.310692, 12.319285, 0.104353, 91.777542, 0.104353 },
               1.124859 },
    { "Nb",    { 17.958399, 12.063054, 5.007015, 3.287667, 1.531019 },
               { 1.211590, 12.246687, 0.098615, 75.011948, 0.098615 },
               1.123452 },
    { "Mo",    { 6.236218, 17.987711, 12.973127, 3.451426, 0.210899 },
               { 0.090780, 1.108310, 11.468720, 66.684151, 0.090780 },
               1.108770 },
    { "Tc",    { 17.840963, 3.428236, 1.373012, 12.947364, 6.335469 },
               { 1.005729, 41.901382, 119.320541, 9.781542, 0.083391 },
               1.074784 },
    { "Ru",    { 6.271624, 17.906738, 14.123269, 3.746008, 0.908235 },
               { 0.077040, 0.928222, 9.555345, 35.860680, 123.552246 },
               1.043992 },
    { "Rh",    { 6.216648, 17.919739, 3.854252, 0.840326, 15.173498 },
               { 0.070789, 0.856121, 33.889484, 121.686691, 9.029517 },
               0.995452 },
    { "Pd",    { 6.121511, 4.784063, 16.631683, 4.318258, 13.246773 },
               { 0.062549, 0.784031, 8.751391, 34.489983, 0.784031 },
               0.883099 },
    { "Ag",    { 6.073874, 17.155437, 4.173344, 0.852238, 17.988686 },
               { 0.055333, 7.896512, 28.443739, 110.376106, 0.716809 },
               0.756603 },
    { "Cd",    { 6.080986, 18.019468, 4.018197, 1.303510, 17.974669 },
               { 0.048990, 7.273646, 29.119284, 95.831207, 0.661231 },
               0.603504 },
    { "In",    { 6.196477, 18.816183, 4.050479, 1.638929, 17.962912 },
               { 0.042072, 6.695665, 31.009790, 103.284348, 0.610714 },
               0.333097 },
    { "Sn",    { 19.325171, 6.281571, 4.498866, 1.856934, 17.917318 },
               { 6.118104, 0.036915, 32.529045, 95.037186, 0.565651 },
               0.119024 },
    { "Sb",    { 5.394956, 6.549570, 19.650681, 1.827820, 17.867832 },
               { 33.326523, 0.030974, 5.564929, 87.130966, 0.523992 },
               -0.290506 },
    { "Te",    { 6.660302, 6.940756, 19.847015, 1.557175, 17.802427 },
               { 33.031654, 0.025750, 5.065547, 84.101616, 0.487660 },
               -0.806668 },
    { "I",     { 19.884502, 6.736593, 8.110516, 1.170953, 17.548716 },
               { 4.628591, 0.027754, 31.849096, 84.406387, 0.463550 },
               -0.448811 },
    { "Xe",    { 19.978920, 11.774945, 9.332182, 1.244749, 17.737501 },
               { 4.143356, 0.010142, 28.796200, 75.280685, 0.413616 },
               -6.065902 },
    { "Cs",    { 17.418674, 8.314444, 10.323193, 1.383834, 19.876251 },
               { 0.399828, 0.016872, 25.605827, 233.339676, 3.826915 },
               -2.322802 },
    { "Ba",    { 19.747343, 17.368477, 10.465718, 2.592602, 11.003653 },
               { 3.481823, 0.371224, 21.226641, 173.834274, 0.010719 },
               -5.183497 },
    { "La",    { 19.966019, 27.329655, 11.018425, 3.086696, 17.335455 },
               { 3.197408, 0.003446, 19.955492, 141.381973, 0.341817 },
               -21.745489 },
    { "Ce",    { 17.355122, 43.988499, 20.546650, 3.130670, 11.353665 },
               { 0.328369, 0.002047, 3.088196, 134.907654, 18.832960 },
               -38.386017 },
    { "Pr",    { 21.551311, 17.161730, 11.903859, 2.679103, 9.564197 },
               { 2.995675, 0.312491, 17.716705, 152.192825, 0.010468 },
               -3.871068 },
    { "Nd",    { 17.331244, 62.783924, 12.160097, 2.663483, 22.239950 },
               { 0.300269, 0.001320, 17.026001, 148.748993, 2.910268 },
               -57.189842 },
    { "Pm",    { 17.286388, 51.560162, 12.478557, 2.675515, 22.960947 },
               { 0.286620, 0.001550, 16.223755, 143.984512, 2.796480 },
               -45.973682 },
    { "Sm",    { 23.700363, 23.072214, 12.777782, 2.684217, 17.204367 },
               { 2.689539, 0.003491, 15.495437, 139.862473, 0.274536 },
               -17.452166 },
    { "Eu",    { 17.186195, 37.156837, 13.103387, 2.707246, 24.419271 },
               { 0.261678, 0.001995, 14.787360, 134.816299, 2.581883 },
               -31.586687 },
    { "Gd",    { 24.898117, 17.104952, 13.222581, 3.266152, 48.995213 },
               { 2.435028, 0.246961, 13.996325, 110.863091, 0.001383 },
               -43.505684 },
    { "Tb",    { 25.910013, 32.344139, 13.765117, 2.751404, 17.064405 },
               { 2.373912, 0.002034, 13.481969, 125.836510, 0.236916 },
               -26.851971 },
    { "Dy",    { 26.671785, 88.687576, 14.065445, 2.768497, 17.067781 },
               { 2.282593, 0.000665, 12.920230, 121.937187, 0.225531 },
               -83.279831 },
    { "Ho",    { 27.150190, 16.999819, 14.059334, 3.386979, 46.546471 },
               { 2.169660, 0.215414, 12.213148, 100.506783, 0.001211 },
               -41.165253 },
    { "Er",    { 28.174887, 82.493271, 14.624002, 2.802756, 17.018515 },
               { 2.120995, 0.000640, 11.915256, 114.529938, 0.207519 },
               -77.135223 },
    { "Tm",    { 28.925894, 76.173798, 14.904704, 2.814812, 16.998117 },
               { 2.046203, 0.000656, 11.465375, 111.411980, 0.199376 },
               -70.839813 },
    { "Yb",    { 29.676760, 65.624069, 15.160854, 2.830288, 16.997850 },
               { 1.977630, 0.000720, 11.044622, 108.139153, 0.192110 },
               -60.313812 },
    { "Lu",    { 30.122866, 15.099346, 56.314899, 3.540980, 16.943729 },
               { 1.883090, 10.342764, 0.000780, 89.559250, 0.183849 },
               -51.049416 },
    { "Hf",    { 30.617033, 15.145351, 54.933548, 4.096253, 16.896156 },
               { 1.795613, 9.934469, 0.000739, 76.189705, 0.175914 },
               -49.719837 },
    { "Ta",    { 31.066359, 15.341823, 49.278297, 4.577665, 16.828321 },
               { 1.708732, 9.618455, 0.000760, 66.346199, 0.168002 },
               -44.119026 },
    { "W",     { 31.507900, 15.682498, 37.960129, 4.885509, 16.792112 },
               { 1.629485, 9.446448, 0.000898, 59.980675, 0.160798 },
               -32.864574 },
    { "Re",    { 31.888456, 16.117104, 42.390297, 5.211669, 16.767591 },
               { 1.549238, 9.233474, 0.000689, 54.516373, 0.152815 },
               -37.412682 },
    { "Os",    { 32.210297, 16.678440, 48.559906, 5.455839, 16.735533 },
               { 1.473531, 9.049695, 0.000519, 50.210201, 0.145771 },
               -43.677956 },
    { "Ir",    { 32.004436, 1.975454, 17.070105, 15.939454, 5.990003 },
               { 1.353767, 81.014175, 0.128093, 7.661196, 26.659403 },
               4.018893 },
    { "Pt",    { 31.273891, 18.445440, 17.063745, 5.555933, 1.575270 },
               { 1.316992, 8.797154, 0.124741, 40.177994, 1.316997 },
               4.050394 },
    { "Au",    { 16.777390, 19.317156, 32.979683, 5.595453, 10.576854 },
               { 0.122737, 8.621570, 1.256902, 38.008820, 0.000601 },
               -6.279078 },
    { "Hg",    { 16.839890, 20.023823, 28.428564, 5.881564, 4.714706 },
               { 0.115905, 8.256927, 1.195250, 39.247227, 1.195250 },
               4.076478 },
    { "Tl",    { 16.630795, 19.386616, 32.808571, 1.747191, 6.356862 },
               { 0.110704, 7.181401, 1.119730, 90.660263, 26.014978 },
               4.066939 },
    { "Pb",    { 16.419567, 32.738590, 6.530247, 2.342742, 19.916475 },
               { 0.105499, 1.055049, 25.025890, 80.906593, 6.664449 },
               4.049824 },
    { "Bi",    { 16.282274, 32.725136, 6.678302, 2.694750, 20.576559 },
               { 0.101180, 1.002287, 25.714146, 77.057549, 6.291882 },
               4.040914 },
    { "Po",    { 16.289164, 32.807171, 21.095163, 2.505901, 7.254589 },
               { 0.098121, 0.966265, 6.046622, 76.598068, 28.096128 },
               4.046556 },
    { "At",    { 16.011461, 32.615547, 8.113899, 2.884082, 21.377867 },
               { 0.092639, 0.904416, 26.543257, 68.372963, 5.499512 },
               3.995684 },
    { "Rn",    { 16.070229, 32.641106, 21.489658, 2.299218, 9.480184 },
               { 0.090437, 0.876409, 5.239687, 69.188477, 27.632641 },
               4.020977 },
    { "Fr",    { 16.007385, 32.663830, 21.594351, 1.598497, 11.121192 },
               { 0.087031, 0.840187, 4.954467, 199.805801, 26.905106 },
               4.003472 },
    { "Ra",    { 32.563690, 21.396671, 11.298093, 2.834688, 15.914965 },
               { 0.801980, 4.590666, 22.758972, 160.404388, 0.083544 },
               3.981773 },
    { "Ac",    { 15.914053, 32.535042, 21.553976, 11.433394, 3.612409 },
               { 0.080511, 0.770669, 4.352206, 21.381622, 130.500748 },
               3.939212 },
    { "Th",    { 15.784024, 32.454899, 21.849222, 4.239077, 11.736191 },
               { 0.077067, 0.735137, 4.097976, 109.464111, 20.512138 },
               3.922533 },
    { "Pa",    { 32.740208, 21.973675, 12.957398, 3.683832, 15.744058 },
               { 0.709545, 4.050881, 19.231543, 117.255005, 0.074040 },
               3.886066 },
    { "U",     { 15.679275, 32.824306, 13.660459, 3.687261, 22.279434 },
               { 0.071206, 0.681177, 18.236156, 112.500038, 3.930325 },
               3.854444 },
    { "Np",    { 32.999901, 22.638077, 14.219973, 3.672950, 15.683245 },
               { 0.657086, 3.854918, 17.435474, 109.464485, 0.068033 },
               3.769391 },
    { "Pu",    { 33.281178, 23.148544, 15.153755, 3.031492, 15.704215 },
               { 0.634999, 3.856168, 16.849735, 121.292038, 0.064857 },
               3.664200 },
    { "Am",    { 33.435162, 23.657259, 15.576339, 3.027023, 15.746100 },
               { 0.612785, 3.792942, 16.195778, 117.757004, 0.061755 },
               3.541160 },
    { "Cm",    { 15.804837, 33.480801, 24.150198, 3.655563, 15.499866 },
               { 0.058619, 0.590160, 3.674720, 100.736191, 15.408296 },
               3.390840 },
    { "Bk",    { 15.889072, 33.625286, 24.710381, 3.707139, 15.839268 },
               { 0.055503, 0.569571, 3.615472, 97.694786, 14.754303 },
               3.213169 },
    { "Cf",    { 33.794075, 25.467693, 16.048487, 3.657525, 16.008982 },
               { 0.550447, 3.581973, 14.357388, 96.064972, 0.052450 },
               3.005326 },
    { "H1-",   { 0.702260, 0.763666, 0.248678, 0.261323, 0.023017 },
               { 23.945604, 74.897919, 6.773289, 233.583450, 1.337531 },
               0.000425 },
    { "Li1+",  { 0.432724, 0.549257, 0.376575, -0.336481, 0.976060 },
               { 0.260367, 1.042836, 7.885294, 0.260368, 3.042539 },
               0.001764 },
    { "Be2+",  { 3.055430, -2.372617, 1.044914, 0.544233, 0.381737 },
               { 0.001226, 0.001227, 1.542106, 0.456279, 4.047479 },
               -0.653773 },
    { "Cval",  { 1.258489, 0.728215, 1.119856, 2.168133, 0.705239 },
               { 10.683769, 0.208177, 0.836097, 24.603704, 58.954273 },
               0.019722 },
    { "O1-",   { 3.106934, 3.235142, 1.148886, 0.783981, 0.676953 },
               { 19.868080, 6.960252, 0.170043, 65.693512, 0.630757 },
               0.046136 },
    { "O2-",   { 3.990247, 2.300563, 0.607200, 1.907882, 1.167080 },
               { 16.639956, 5.636819, 0.108493, 47.299709, 0.379984 },
               0.025429 },
    { "F1-",   { 0.457649, 3.841561, 1.432771, 0.801876, 3.395041 },
               { 0.917243, 5.507803, 0.164955, 51.076206, 15.821679 },
               0.069525 },
    { "Na1+",  { 3.148690, 4.073989, 0.767888, 0.995612, 0.968249 },
               { 2.594987, 6.046925, 0.070139, 14.122657, 0.217037 },
               0.045300 },
    { "Mg2+",  { 3.062918, 4.135106, 0.853742, 1.036792, 0.852520 },
               { 2.015803, 4.417941, 0.065307, 9.669710, 0.187818 },
               0.058851 },
    { "Al3+",  { 4.132015, 0.912049, 1.102425, 0.614876, 3.219136 },
               { 3.528641, 7.378344, 0.133708, 0.039065, 1.644728 },
               0.019397 },
    { "Sival", { 2.879033, 3.072960, 1.515981, 1.390030, 4.995051 },
               { 1.239713, 38.706276, 0.081481, 93.616333, 2.770293 },
               0.146030 },
               /* was "Siva" */
    { "Si4+",  { 3.676722, 3.828496, 1.258033, 0.419024, 0.720421 },
               { 1.446851, 3.013144, 0.064397, 0.206254, 5.970222 },
               0.097266 },
    { "Cl1-",  { 1.061802, 7.139886, 6.524271, 2.355626, 35.829403 },
               { 0.144727, 1.171795, 19.467655, 60.320301, 0.000436 },
               -34.916603 },
    { "K1+",   { -17.609339, 1.494873, 7.150305, 10.899569, 15.808228 },
               { 18.840979, 0.053453, 0.812940, 22.264105, 14.351593 },
               0.257164 },
    { "Ca2+",  { 8.501441, 12.880483, 9.765095, 7.156669, 0.711160 },
               { 10.525848, -0.004033, 0.010692, 0.684443, 27.231771 },
               -21.013187 },
    { "Sc3+",  { 7.104348, 1.511488, -53.669773, 38.404816, 24.532240 },
               { 0.601957, 0.033386, 12.572138, 10.859736, 14.125230 },
               0.118642 },
    { "Ti2+",  { 7.040119, 1.496285, 9.657304, 0.006534, 1.649561 },
               { 0.537072, 0.031914, 8.009958, 201.800293, 24.039482 },
               0.150362 },
    { "Ti3+",  { 36.587933, 7.230255, -9.086077, 2.084594, 17.294008 },
               { 0.000681, 0.522262, 5.262317, 15.881716, 6.149805 },
               -35.111282 },
    { "Ti4+",  { 45.355537, 7.092900, 7.483858, -43.498817, 1.678915 },
               { 9.252186, 0.523046, 13.082852, 10.193876, 0.023064 },
               -0.110628 },
    { "V2+",   { 7.754356, 2.064100, 2.576998, 2.011404, 7.126177 },
               { 7.066315, 0.014993, 7.066308, 22.055786, 0.467568 },
               -0.533379 },
    { "V3+",   { 9.958480, 1.596350, 1.483442, -10.846044, 17.332867 },
               { 6.763041, 0.056895, 17.750029, 0.328826, 0.388013 },
               0.474921 },
    { "V5+",   { 15.575018, 8.448095, 1.612040, -9.721855, 1.534029 },
               { 0.682708, 5.566640, 10.527077, 0.907961, 0.066667 },
               0.552676 },
    { "Cr2+",  { 10.598877, 1.565858, 2.728280, 0.098064, 6.959321 },
               { 6.151846, 0.023519, 17.432816, 54.002388, 0.426301 },
               0.049870 },
    { "Cr3+",  { 7.989310, 1.765079, 2.627125, 1.829380, 6.980908 },
               { 6.068867, 0.018342, 6.068887, 16.309284, 0.420864 },
               -0.192123 },
    { "Mn2+",  { 11.287712, 26.042414, 3.058096, 0.090258, 7.088306 },
               { 5.506225, 0.000774, 16.158575, 54.766354, 0.375580 },
               -24.566132 },
    { "Mn3+",  { 6.926972, 2.081342, 11.128379, 2.375107, -0.419287 },
               { 0.378315, 0.015054, 5.379957, 14.429586, 0.004939 },
               -0.093713 },
    { "Mn4+",  { 12.409131, 7.466993, 1.809947, -12.138477, 10.780248 },
               { 0.300400, 0.112814, 12.520756, 0.168653, 5.173237 },
               0.672146 },
    { "Fe2+",  { 11.776765, 11.165097, 3.533495, 0.165345, 7.036932 },
               { 4.912232, 0.001748, 14.166556, 42.381958, 0.341324 },
               -9.676919 },
    { "Fe3+",  { 9.721638, 63.403847, 2.141347, 2.629274, 7.033846 },
               { 4.869297, 0.000293, 4.867602, 13.539076, 0.338520 },
               -61.930725 },
    { "Co2+",  { 6.993840, 26.285812, 12.254289, 0.246114, 4.017407 },
               { 0.310779, 0.000684, 4.400528, 35.741447, 12.536393 },
               -24.796852 },
    { "Co3+",  { 6.861739, 2.678570, 12.281889, 3.501741, -0.179384 },
               { 0.309794, 0.008142, 4.331703, 11.914167, 11.914167 },
               -1.147345 },
    { "Ni2+",  { 12.519017, 37.832058, 4.387257, 0.661552, 6.949072 },
               { 3.933053, 0.000442, 10.449184, 23.860998, 0.283723 },
               -36.344471 },
    { "Ni3+",  { 13.579366, 1.902844, 12.859268, 3.811005, -6.838595 },
               { 0.313140, 0.012621, 3.906407, 10.894311, 0.344379 },
               -0.317618 },
    { "Cu1+",  { 12.960763, 16.342150, 1.110102, 5.520682, 6.915452 },
               { 3.576010, 0.000975, 29.523218, 10.114283, 0.261326 },
               -14.849320 },
    { "Cu2+",  { 11.895569, 16.344978, 5.799817, 1.048804, 6.789088 },
               { 3.378519, 0.000924, 8.133653, 20.526524, 0.254741 },
               -14.878383 },
    { "Zn2+",  { 13.340772, 10.428857, 5.544489, 0.762295, 6.869172 },
               { 3.215913, 0.001413, 8.542680, 21.891756, 0.239215 },
               -8.945248 },
    { "Ga3+",  { 13.123875, 35.288189, 6.126979, 0.611551, 6.724807 },
               { 2.809960, 0.000323, 6.831534, 16.784311, 0.212002 },
               -33.875122 },
    { "Ge4+",  { 6.876636, 6.779091, 9.969591, 3.135857, 0.152389 },
               { 2.025174, 0.176650, 3.573822, 7.685848, 16.677574 },
               1.086542 },
    { "Br1-",  { 17.714310, 6.466926, 6.947385, 4.402674, -0.697279 },
               { 2.122554, 19.050768, 0.152708, 58.690361, 58.690372 },
               1.152674 },
    { "Rb1+",  { 17.684320, 7.761588, 6.680874, 2.668883, 0.070974 },
               { 1.710209, 14.919863, 0.128542, 31.654478, 0.128543 },
               1.133263 },
    { "Sr2+",  { 17.694973, 1.275762, 6.154252, 9.234786, 0.515995 },
               { 1.550888, 30.133041, 0.118774, 13.821799, 0.118774 },
               1.125309 },
    { "Y3+",   { 46.660366, 10.369686, 4.623042, -62.170834, 17.471146 },
               { -0.019971, 13.180257, 0.176398, -0.016727, 1.467348 },
               19.023842 },
    { "Zr4+",  { 6.802956, 17.699253, 10.650647, -0.248108, 0.250338 },
               { 0.096228, 1.296127, 11.240715, -0.219259, -0.219021 },
               0.827902 },
    { "Nb3+",  { 17.714323, 1.675213, 7.483963, 8.322464, 11.143573 },
               { 1.172419, 30.102791, 0.080255, -0.002983, 10.456687 },
               -8.339573 },
    { "Nb5+",  { 17.580206, 7.633277, 10.793497, 0.180884, 67.837921 },
               { 1.165852, 0.078558, 9.507652, 31.621656, -0.000438 },
               -68.024780 },
    { "Mo3+",  { 7.447050, 17.778122, 11.886068, 1.997905, 1.789626 },
               { 0.072000, 1.073145, 9.834720, 28.221746, -0.011674 },
               -1.898764 },
    { "Mo5+",  { 7.929879, 17.667669, 11.515987, 0.500402, 77.444084 },
               { 0.068856, 1.068064, 9.046229, 26.558945, -0.000473 },
               -78.056595 },
    { "Mo6+",  { 34.757683, 9.653037, 6.584769, -18.628115, 2.490594 },
               { 1.301770, 7.123843, 0.094097, 1.617443, 12.335434 },
               1.141916 },
    { "Ru3+",  { 17.894758, 13.579529, 10.729251, 2.474095, 48.227997 },
               { 0.902827, 8.740579, 0.045125, 24.764954, -0.001699 },
               -51.905243 },
    { "Ru4+",  { 17.845776, 13.455084, 10.229087, 1.653524, 14.059795 },
               { 0.901070, 8.482392, 0.045972, 23.015272, -0.004889 },
               -17.241762 },
    { "Rh3+",  { 17.758621, 14.569813, 5.298320, 2.533579, 0.879753 },
               { 0.841779, 8.319533, 0.069050, 23.709131, 0.069050 },
               0.960843 },
    { "Rh4+",  { 17.716188, 14.446654, 5.185801, 1.703448, 0.989992 },
               { 0.840572, 8.100647, 0.068995, 22.357307, 0.068995 },
               0.959941 },
    { "Pd2+",  { 6.122282, 15.651012, 3.513508, 9.060790, 8.771199 },
               { 0.062424, 8.018296, 24.784275, 0.776457, 0.776457 },
               0.879336 },
    { "Pd4+",  { 6.152421, -96.069023, 31.622141, 81.578255, 17.801403 },
               { 0.063951, 11.090354, 13.466152, 9.758302, 0.783014 },
               0.915874 },
    { "Ag1+",  { 6.091192, 4.019526, 16.948174, 4.258638, 13.889437 },
               { 0.056305, 0.719340, 7.758938, 27.368349, 0.719340 },
               0.785127 },
    { "Ag2+",  { 6.401808, 48.699802, 4.799859, -32.332523, 16.356710 },
               { 0.068167, 0.942270, 20.639496, 1.100365, 6.883131 },
               1.068247 },
    { "Cd2+",  { 6.093711, 43.909691, 17.041306, -39.675117, 17.958918 },
               { 0.050624, 8.654143, 15.621396, 11.082067, 0.667591 },
               0.664795 },
    { "In3+",  { 6.206277, 18.497746, 3.078131, 10.524613, 7.401234 },
               { 0.041357, 6.605563, 18.792250, 0.608082, 0.608082 },
               0.293677 },
    { "Sn2+",  { 6.353672, 4.770377, 14.672025, 4.235959, 18.002131 },
               { 0.034720, 6.167891, 6.167879, 29.006456, 0.561774 },
               -0.042519 },
    { "Sn4+",  { 15.445732, 6.420892, 4.562980, 1.713385, 18.033537 },
               { 6.280898, 0.033144, 6.280899, 17.983601, 0.557980 },
               -0.172219 },
    { "Sb3+",  { 10.189171, 57.461918, 19.356573, 4.862206, -45.394096 },
               { 0.089485, 0.375256, 5.357987, 22.153736, 0.297768 },
               1.516108 },
    { "Sb5+",  { 17.920622, 6.647932, 12.724075, 1.555545, 7.600591 },
               { 0.522315, 0.029487, 5.718210, 16.433775, 5.718204 },
               -0.445371 },
    { "I1-",   { 20.010330, 17.835524, 8.104130, 2.231118, 9.158548 },
               { 4.565931, 0.444266, 32.430672, 95.149040, 0.014906 },
               -3.341004 },
    { "Cs1+",  { 19.939056, 24.967621, 10.375884, 0.454243, 17.660248 },
               { 3.770511, 0.004040, 25.311275, 76.537766, 0.384730 },
               -19.394306 },
    { "Ba2+",  { 19.750200, 17.513683, 10.884892, 0.321585, 65.149834 },
               { 3.430748, 0.361590, 21.358307, 70.309402, 0.001418 },
               -59.618172 },
    { "La3+",  { 19.688887, 17.345703, 11.356296, 0.099418, 82.358124 },
               { 3.146211, 0.339586, 18.753832, 90.345459, 0.001072 },
               -76.846909 },
    { "Ce3+",  { 26.593231, 85.866432, -6.677695, 12.111847, 17.401903 },
               { 3.280381, 0.001012, 4.313575, 17.868504, 0.326962 },
               -80.313423 },
    { "Ce4+",  { 17.457533, 25.659941, 11.691037, 19.695251, -16.994749 },
               { 0.311812, -0.003793, 16.568687, 2.886395, -0.008931 },
               -3.515096 },
    { "Pr3+",  { 20.879841, 36.035797, 12.135341, 0.283103, 17.167803 },
               { 2.870897, 0.002364, 16.615236, 53.909359, 0.306993 },
               -30.500784 },
    { "Pr4+",  { 17.496082, 21.538509, 20.403114, 12.062211, -7.492043 },
               { 0.294457, -0.002742, 2.772886, 15.804613, -0.013556 },
               -9.016722 },
    { "Nd3+",  { 17.120077, 56.038139, 21.468307, 10.000671, 2.905866 },
               { 0.291295, 0.001421, 2.743681, 14.581367, 22.485098 },
               -50.541992 },
    { "Pm3+",  { 22.221066, 17.068142, 12.805423, 0.435687, 52.238770 },
               { 2.635767, 0.277039, 14.927315, 45.768017, 0.001455 },
               -46.767181 },
    { "Sm3+",  { 15.618565, 19.538092, 13.398946, -4.358811, 24.490461 },
               { 0.006001, 0.306379, 14.979594, 0.748825, 2.454492 },
               -9.714854 },
    { "Eu2+",  { 23.899035, 31.657497, 12.955752, 1.700576, 16.992199 },
               { 2.467332, 0.002230, 13.625002, 35.089481, 0.253136 },
               -26.204315 },
    { "Eu3+",  { 17.758327, 33.498665, 24.067188, 13.436883, -9.019134 },
               { 0.244474, -0.003901, 2.487526, 14.568011, -0.015628 },
               -19.768026 },
    { "Gd3+",  { 24.344999, 16.945311, 13.866931, 0.481674, 93.506378 },
               { 2.333971, 0.239215, 12.982995, 43.876347, 0.000673 },
               -88.147179 },
    { "Tb3+",  { 24.878252, 16.856016, 13.663937, 1.279671, 39.271294 },
               { 2.223301, 0.227290, 11.812528, 29.910065, 0.001527 },
               -33.950317 },
    { "Dy3+",  { 16.864344, 90.383461, 13.675473, 1.687078, 25.540651 },
               { 0.216275, 0.000593, 11.121207, 26.250975, 2.135930 },
               -85.150650 },
    { "Ho3+",  { 16.837524, 63.221336, 13.703766, 2.061602, 26.202621 },
               { 0.206873, 0.000796, 10.500283, 24.031883, 2.055060 },
               -58.026505 },
    { "Er3+",  { 16.810127, 22.681061, 13.864114, 2.294506, 26.864477 },
               { 0.198293, 0.002126, 9.973341, 22.836388, 1.979442 },
               -17.513460 },
    { "Tm3+",  { 16.787500, 15.350905, 14.182357, 2.299111, 27.573771 },
               { 0.190852, 0.003036, 9.602934, 22.526880, 1.912862 },
               -10.192087 },
    { "Yb2+",  { 28.443794, 16.849527, 14.165081, 3.445311, 28.308853 },
               { 1.863896, 0.183811, 9.225469, 23.691355, 0.001463 },
               -23.214935 },
    { "Yb3+",  { 28.191629, 16.828087, 14.167848, 2.744962, 23.171774 },
               { 1.842889, 0.182788, 9.045957, 20.799847, 0.001759 },
               -18.103676 },
    { "Lu3+",  { 28.828693, 16.823227, 14.247617, 3.079559, 25.647667 },
               { 1.776641, 0.175560, 8.575531, 19.693701, 0.001453 },
               -20.626528 },
    { "Hf4+",  { 29.267378, 16.792543, 14.785310, 2.184128, 23.791996 },
               { 1.697911, 0.168313, 8.190025, 18.277578, 0.001431 },
               -18.820383 },
    { "Ta5+",  { 29.539469, 16.741854, 15.182070, 1.642916, 16.437447 },
               { 1.612934, 0.160460, 7.654408, 17.070732, 0.001858 },
               -11.542459 },
    { "W6+",   { 29.729357, 17.247808, 15.184488, 1.154652, 0.739335 },
               { 1.501648, 0.140803, 6.880573, 14.299601, 14.299618 },
               3.945157 },
    { "Os4+",  { 17.113485, 15.792370, 23.342392, 4.090271, 7.671292 },
               { 0.131850, 7.288542, 1.389307, 19.629425, 1.389307 },
               3.988390 },
    { "Ir3+",  { 31.537575, 16.363338, 15.597141, 5.051404, 1.436935 },
               { 1.334144, 7.451918, 0.127514, 21.705648, 0.127515 },
               4.009459 },
    { "Ir4+",  { 30.391249, 16.146996, 17.019068, 4.458904, 0.975372 },
               { 1.328519, 7.181766, 0.127337, 19.060146, 1.328519 },
               4.006865 },
    { "Pt2+",  { 31.986849, 17.249048, 15.269374, 5.760234, 1.694079 },
               { 1.281143, 7.625512, 0.123571, 24.190826, 0.123571 },
               4.032512 },
    { "Pt4+",  { 41.932713, 16.339224, 17.653894, 6.012420, -12.036877 },
               { 1.111409, 6.466086, 0.128917, 16.954155, 0.778721 },
               4.094551 },
    { "Au1+",  { 32.124306, 16.716476, 16.814100, 7.311565, 0.993064 },
               { 1.216073, 7.165378, 0.118715, 20.442486, 53.095985 },
               4.040792 },
    { "Au3+",  { 31.704271, 17.545767, 16.819551, 5.522640, 0.361725 },
               { 1.215561, 7.220506, 0.118812, 20.050970, 1.215562 },
               4.042679 },
    { "Hg1+",  { 28.866837, 19.277540, 16.776051, 6.281459, 3.710289 },
               { 1.173967, 7.583842, 0.115351, 29.055994, 1.173968 },
               4.068430 },
    { "Hg2+",  { 32.411079, 18.690371, 16.711773, 9.974835, -3.847611 },
               { 1.162980, 7.329806, 0.114518, 22.009489, 22.009493 },
               4.052869 },
    { "Tl1+",  { 32.295044, 16.570049, 17.991013, 1.535355, 7.554591 },
               { 1.101544, 0.110020, 6.528559, 52.495068, 20.338634 },
               4.054030 },
    { "Tl3+",  { 32.525639, 19.139185, 17.100321, 5.891115, 12.599463 },
               { 1.094966, 6.900992, 0.103667, 18.489614, -0.001401 },
               -9.256075 },
    { "Pb2+",  { 27.392647, 16.496822, 19.984501, 6.813923, 5.233910 },
               { 1.058874, 0.106305, 6.708123, 24.395554, 1.058874 },
               4.065623 },
    { "Pb4+",  { 32.505657, 20.014240, 14.645661, 5.029499, 1.760138 },
               { 1.047035, 6.670321, 0.105279, 16.525040, 0.105279 },
               4.044678 },
    { "Bi3+",  { 32.461437, 19.438683, 16.302486, 7.322662, 0.431704 },
               { 0.997930, 6.038867, 0.101338, 18.371586, 46.361046 },
               4.043703 },
    { "Bi5+",  { 16.734028, 20.580494, 9.452623, 61.155834, -34.041023 },
               { 0.105076, 4.773282, 11.762162, 1.211775, 1.619408 },
               4.113663 },
    { "Ra2+",  { 4.986228, 32.474945, 21.947443, 11.800013, 10.807292 },
               { 0.082597, 0.791468, 4.608034, 24.792431, 0.082597 },
               3.956572 },
    { "Ac3+",  { 15.584983, 32.022125, 21.456327, 0.757593, 12.341252 },
               { 0.077438, 0.739963, 4.040735, 47.525002, 19.406845 },
               3.838984 },
    { "Th4+",  { 15.515445, 32.090691, 13.996399, 12.918157, 7.635514 },
               { 0.074499, 0.711663, 3.871044, 18.596891, 3.871044 },
               3.831122 },
    { "U3+",   { 15.360309, 32.395657, 21.961290, 1.325894, 14.251453 },
               { 0.067815, 0.654643, 3.643409, 39.604965, 16.330570 },
               3.706622 },
    { "U4+",   { 15.355091, 32.235306, 0.557745, 14.396367, 21.751173 },
               { 0.067789, 0.652613, 42.354237, 15.908239, 3.553231 },
               3.705863 },
    { "U6+",   { 15.333844, 31.770849, 21.274414, 13.872636, 0.048519 },
               { 0.067644, 0.646384, 3.317894, 14.650250, 75.339699 },
               3.700591 },
    { "Np3+",  { 15.378152, 32.572132, 22.206125, 1.413295, 14.828381 },
               { 0.064613, 0.631420, 3.561936, 37.875511, 15.546129 },
               3.603370 },
    { "Np4+",  { 15.373926, 32.423019, 21.969994, 0.662078, 14.969350 },
               { 0.064597, 0.629658, 3.476389, 39.438942, 15.135764 },
               3.603039 },
    { "Np6+",  { 15.359986, 31.992825, 21.412458, 0.066574, 14.568174 },
               { 0.064528, 0.624505, 3.253441, 67.658318, 13.980832 },
               3.600942 },
    { "Pu3+",  { 15.356004, 32.769127, 22.680210, 1.351055, 15.416232 },
               { 0.060590, 0.604663, 3.491509, 37.260635, 14.981921 },
               3.428895 },
    { "Pu4+",  { 15.416219, 32.610569, 22.256662, 0.719495, 15.518152 },
               { 0.061456, 0.607938, 3.411848, 37.628792, 14.464360 },
               3.480408 },
    { "Pu6+",  { 15.436506, 32.289719, 14.726737, 15.012391, 7.024677 },
               { 0.061815, 0.606541, 3.245363, 13.616438, 3.245364 },
               3.502325 },
    { "Es",    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. },
    { "Fm",    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. },
    { "Md",    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. },
    { "No",    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. },
    { "Lr",    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. },
    { NULL,    { 0., 0., 0., 0., 0. },
               { 0., 0., 0., 0., 0. },
               0. }
  };
#endif /* ATOMINFO_C__ */


/* Table of ionic radii

   Reference:
                          U s e r ' s  M a n u a l
                         I C S D  -  C R Y S T I N
                         =========================
                    Inorganic Crystal Structure Database
                            in conjunction with
                   Crystal Structure Information System
                           and its application to
                CCDF - Cambridge Crystallographic Data File
                                    and
                           MDF - Metal Data File
                    G.Bergerhoff, B.Kilger, C.Witthauer,
                            R.Hundt, R.Sievers
                                    Bonn
                                    1986
             Institut fuer Anorganische Chemie der Universitaet
            -------------------------------------------------------------
            ICSD/CRYSTIN User's Manual.
            English Version. Translated by Ruth Schubert.
            Updated Dec. 1986.


            These radii are also the basis of the distance tests,  which are
            routinely  carried  out when collecting data in the ICSD system.
            In  this  connection,   negative increments are obtained for the
            specially small atoms C+4, D+1, H+1 and N+5.


   Radii "not in ICSD manual" were taken from Xtal 3.2 routine SX20
 */


typedef struct
  {
    const char  *Label;
    float       Radius;
  }
  T_AtomRadius;


#ifndef ATOMINFO_C__
extern
const T_AtomRadius ListAtomRadius[];
#else
const T_AtomRadius ListAtomRadius[] =
  {
    { "H",     0.78 },
    { "H1+",  -0.38 },
    { "H1-",   1.40 },
    { "D",     0.78 },
    { "D1+",  -0.24 },
    { "D1-",   1.40 },
    { "He",    1.00 },
    { "Li",    1.56 },
    { "Li1+",  0.59 },
    { "Be",    1.13 },
    { "Be2+",  0.17 },
    { "B",     0.95 },
    { "B1+",   0.58 },
    { "B2+",   0.40 },
    { "B3+",   0.02 },
    { "B2-",   1.06 },
    { "B3-",   1.22 },
    { "C",     0.86 },
    { "C1+",   0.79 },
    { "C2+",   0.60 },
    { "C3+",   0.55 },
    { "C4+",  -0.08 },
    { "C1-",   1.10 },
    { "C2-",   1.38 },
    { "C4-",   1.77 },
    { "N",     0.80 },
    { "N1+",   0.59 },
    { "N2+",   0.37 },
    { "N3+",   0.16 },
    { "N4+",   0.15 },
    { "N5+",  -0.12 },
    { "N1-",   1.10 },
    { "N2-",   1.29 },
    { "N3-",   1.48 },
    { "O",     0.66 },
    { "O1-",   0.93 },
    { "O2-",   1.21 },
    { "F",     0.64 },
    { "F7+",   0.08 },
    { "F1-",   1.15 },
    { "Ne",    1.00 },
    { "Na",    1.91 },
    { "Na1+",  0.97 },
    { "Mg",    1.60 },
    { "Mg2+",  0.49 },
    { "Al",    1.43 },
    { "Al3+",  0.39 },
    { "Si",    1.34 },
    { "Si2+",  1.25 },
    { "Si3+",  1.17 },
    { "Si4+",  0.26 },
    { "Si1-",  1.41 },
    { "Si4-",  2.72 },
    { "P",     1.30 },
    { "P1+",   1.01 },
    { "P2+",   0.73 },
    { "P3+",   0.44 },
    { "P4+",   0.40 },
    { "P5+",   0.17 },
    { "P1-",   1.59 },
    { "P2-",   1.20 },
    { "P3-",   2.17 },
    { "S",     1.04 },
    { "S1+",   1.26 },
    { "S2+",   0.87 },
    { "S3+",   0.62 },
    { "S4+",   0.37 },
    { "S5+",   0.34 },
    { "S6+",   0.12 },
    { "S1-",   1.44 },
    { "S2-",   1.84 },
    { "Cl",    1.62 },
    { "Cl1+",  1.30 },
    { "Cl3+",  1.05 },
    { "Cl5+",  0.12 },
    { "Cl7+",  0.20 },
    { "Cl1-",  1.81 },
    { "Ar",    1.00 },
    { "K",     2.34 },
    { "K1+",   1.33 },
    { "Ca",    1.97 },
    { "Ca1+",  1.70 },
    { "Ca2+",  0.99 },
    { "Sc",    1.64 },
    { "Sc1+",  1.36 },
    { "Sc2+",  1.09 },
    { "Sc3+",  0.73 },
    { "Ti",    1.45 },
    { "Ti2+",  0.86 },
    { "Ti3+",  0.67 },
    { "Ti4+",  0.53 },
    { "V",     1.35 },
    { "V1+",   1.02 },
    { "V2+",   0.79 },
    { "V3+",   0.64 },
    { "V4+",   0.59 },
    { "V5+",   0.36 },
    { "Cr",    1.27 },
    { "Cr1+",  1.07 },
    { "Cr2+",  0.73 },
    { "Cr3+",  0.62 },
    { "Cr4+",  0.44 },
    { "Cr5+",  0.35 },
    { "Cr6+",  0.30 },
    { "Mn",    1.32 },
    { "Mn1+",  0.88 },
    { "Mn2+",  0.67 },
    { "Mn3+",  0.58 },
    { "Mn4+",  0.54 },
    { "Mn5+",  0.55 },
    { "Mn6+",  0.27 },
    { "Mn7+",  0.26 },
    { "Mn1-",  1.06 },
    { "Fe",    1.27 },
    { "Fe1+",  0.84 },
    { "Fe2+",  0.61 },
    { "Fe3+",  0.49 },
    { "Fe4+",  0.54 },
    { "Fe6+",  0.30 },
    { "Co",    1.26 },
    { "Co1+",  0.80 },
    { "Co2+",  0.65 },
    { "Co3+",  0.52 },
    { "Co4+",  0.54 },
    { "Co1-",  1.30 },
    { "Ni",    1.24 },
    { "Ni1+",  0.68 },
    { "Ni2+",  0.69 },
    { "Ni3+",  0.60 },
    { "Ni4+",  0.56 },
    { "Cu",    1.28 },
    { "Cu1+",  0.46 },
    { "Cu2+",  0.62 },
    { "Cu3+",  0.60 },
    { "Zn",    1.39 },
    { "Zn2+",  0.60 },
    { "Ga",    1.40 },
    { "Ga1+",  1.14 },
    { "Ga2+",  0.88 },
    { "Ga3+",  0.47 },
    { "Ge",    1.40 },
    { "Ge2+",  0.73 },
    { "Ge3+",  0.63 },
    { "Ge4+",  0.40 },
    { "Ge4-",  2.72 },
    { "As",    1.50 },
    { "As2+",  0.52 },
    { "As3+",  0.58 },
    { "As4+",  0.64 },
    { "As5+",  0.33 },
    { "As1-",  1.59 },
    { "As2-",  1.85 },
    { "As3-",  2.11 },
    { "Se",    1.60 },
    { "Se1+",  1.39 },
    { "Se2+",  1.08 },
    { "Se4+",  0.50 },
    { "Se6+",  0.29 },
    { "Se1-",  1.77 },
    { "Se2-",  1.98 },
    { "Br",    1.11 },
    { "Br1+",  1.06 },
    { "Br3+",  0.82 },
    { "Br5+",  0.59 },
    { "Br7+",  0.39 },
    { "Br1-",  1.96 },
    { "Kr",    1.14 }, /* not in ICSD manual */
    { "Kr2+",  0.74 },
    { "Rb",    2.50 },
    { "Rb1+",  1.47 },
    { "Sr",    2.15 },
    { "Sr2+",  1.12 },
    { "Y",     1.80 },
    { "Y1+",   1.11 },
    { "Y2+",   1.30 },
    { "Y3+",   0.89 },
    { "Zr",    1.60 },
    { "Zr1+",  1.42 },
    { "Zr2+",  1.21 },
    { "Zr3+",  0.89 },
    { "Zr4+",  0.72 },
    { "Nb",    1.48 },
    { "Nb1+",  1.00 },
    { "Nb2+",  0.71 },
    { "Nb3+",  0.70 },
    { "Nb4+",  0.69 },
    { "Nb5+",  0.32 },
    { "Mo",    1.40 },
    { "Mo1+",  1.00 },
    { "Mo2+",  0.92 },
    { "Mo3+",  0.67 },
    { "Mo4+",  0.65 },
    { "Mo5+",  0.63 },
    { "Mo6+",  0.42 },
    { "Tc",    1.35 },
    { "Tc2+",  1.00 },
    { "Tc3+",  0.80 },
    { "Tc4+",  0.64 },
    { "Tc6+",  0.56 },
    { "Tc7+",  0.98 },
    { "Ru",    1.32 },
    { "Ru2+",  0.90 },
    { "Ru3+",  0.68 },
    { "Ru4+",  0.62 },
    { "Ru5+",  0.52 },
    { "Ru6+",  0.37 },
    { "Ru7+",  0.54 },
    { "Rh",    1.34 },
    { "Rh1+",  0.82 },
    { "Rh2+",  0.75 },
    { "Rh3+",  0.67 },
    { "Rh4+",  0.62 },
    { "Rh5+",  0.55 },
    { "Rh1-",  1.54 },
    { "Pd",    1.37 },
    { "Pd1+",  0.59 },
    { "Pd2+",  0.64 },
    { "Pd3+",  0.76 },
    { "Pd4+",  0.62 },
    { "Ag",    1.44 },
    { "Ag1+",  0.67 },
    { "Ag2+",  0.89 },
    { "Ag3+",  0.65 },
    { "Cd",    1.57 },
    { "Cd2+",  0.84 },
    { "In",    1.66 },
    { "In1+",  1.35 },
    { "In2+",  1.08 },
    { "In3+",  0.79 },
    { "Sn",    1.58 },
    { "Sn2+",  0.93 },
    { "Sn3+",  0.82 },
    { "Sn4+",  0.69 },
    { "Sb",    1.60 },
    { "Sb2+",  0.83 },
    { "Sb3+",  0.76 },
    { "Sb4+",  0.69 },
    { "Sb5+",  0.61 },
    { "Sb6+",  0.75 },
    { "Sb2-",  2.16 },
    { "Sb3-",  2.44 },
    { "Te",    1.70 },
    { "Te1+",  1.45 },
    { "Te2+",  1.20 },
    { "Te4+",  0.52 },
    { "Te6+",  0.56 },
    { "Te1-",  1.95 },
    { "Te2-",  2.21 },
    { "I",     1.95 },
    { "I1+",   1.70 },
    { "I3+",   1.39 },
    { "I5+",   0.62 },
    { "I7+",   0.50 },
    { "I1-",   2.20 },
    { "Xe",    1.33 }, /* not in ICSD manual */
    { "Xe2+",  1.10 },
    { "Xe4+",  0.83 },
    { "Xe6+",  0.55 },
    { "Xe8+",  0.40 },
    { "Cs",    2.71 },
    { "Cs1+",  1.67 },
    { "Ba",    2.24 },
    { "Ba2+",  1.34 },
    { "La",    1.87 },
    { "La1+",  1.40 },
    { "La2+",  1.27 },
    { "La3+",  1.06 },
    { "La4+",  1.01 },
    { "Ce",    1.82 },
    { "Ce2+",  1.30 },
    { "Ce3+",  1.03 },
    { "Ce4+",  0.80 },
    { "Pr",    1.83 },
    { "Pr2+",  1.00 },
    { "Pr3+",  1.01 },
    { "Pr4+",  0.78 },
    { "Nd",    1.82 },
    { "Nd2+",  1.30 },
    { "Nd3+",  1.00 },
    { "Nd4+",  0.90 },
    { "Pm",    1.63 }, /* not in ICSD manual */
    { "Pm3+",  0.98 },
    { "Sm",    1.80 },
    { "Sm2+",  1.10 },
    { "Sm3+",  0.96 },
    { "Eu",    2.04 },
    { "Eu2+",  1.17 },
    { "Eu3+",  0.95 },
    { "Eu4+",  0.65 },
    { "Gd",    1.80 },
    { "Gd1+",  0.91 },
    { "Gd2+",  0.94 },
    { "Gd3+",  0.94 },
    { "Gd4+",  1.00 },
    { "Tb",    1.78 },
    { "Tb1+",  1.50 },
    { "Tb2+",  1.22 },
    { "Tb3+",  0.92 },
    { "Tb4+",  0.76 },
    { "Dy",    1.77 },
    { "Dy2+",  1.10 },
    { "Dy3+",  0.91 },
    { "Ho",    1.77 },
    { "Ho2+",  1.10 },
    { "Ho3+",  0.89 },
    { "Er",    1.76 },
    { "Er1+",  1.50 },
    { "Er2+",  1.20 },
    { "Er3+",  0.88 },
    { "Tm",    1.75 },
    { "Tm2+",  1.16 },
    { "Tm3+",  0.87 },
    { "Yb",    1.94 },
    { "Yb2+",  0.90 },
    { "Yb3+",  0.86 },
    { "Lu",    1.73 },
    { "Lu2+",  1.20 },
    { "Lu3+",  0.85 },
    { "Hf",    1.59 },
    { "Hf2+",  1.10 },
    { "Hf3+",  0.97 },
    { "Hf4+",  0.71 },
    { "Ta",    1.48 },
    { "Ta1+",  0.88 },
    { "Ta2+",  0.83 },
    { "Ta3+",  0.67 },
    { "Ta4+",  0.66 },
    { "Ta5+",  0.64 },
    { "W",     1.41 },
    { "W2+",   0.80 },
    { "W3+",   0.75 },
    { "W4+",   0.65 },
    { "W5+",   0.66 },
    { "W6+",   0.41 },
    { "Re",    1.46 },
    { "Re1+",  1.23 },
    { "Re2+",  1.00 },
    { "Re3+",  0.77 },
    { "Re4+",  0.63 },
    { "Re5+",  0.52 },
    { "Re6+",  0.52 },
    { "Re7+",  0.40 },
    { "Os",    1.34 },
    { "Os1+",  1.20 },
    { "Os2+",  1.05 },
    { "Os4+",  0.63 },
    { "Os5+",  0.51 },
    { "Os6+",  0.33 },
    { "Os7+",  0.27 },
    { "Os8+",  0.20 },
    { "Ir",    1.36 },
    { "Ir1+",  1.37 },
    { "Ir2+",  1.00 },
    { "Ir3+",  0.73 },
    { "Ir4+",  0.63 },
    { "Ir5+",  0.68 },
    { "Pt",    1.39 },
    { "Pt2+",  0.80 },
    { "Pt3+",  0.73 },
    { "Pt4+",  0.63 },
    { "Pt5+",  0.58 },
    { "Pt6+",  0.50 },
    { "Au",    1.44 },
    { "Au1+",  1.37 },
    { "Au2+",  1.11 },
    { "Au3+",  0.70 },
    { "Au5+",  0.70 },
    { "Hg",    1.62 },
    { "Hg1+",  0.97 },
    { "Hg2+",  0.69 },
    { "Tl",    1.73 },
    { "Tl1+",  1.47 },
    { "Tl3+",  0.88 },
    { "Pb",    1.75 },
    { "Pb2+",  0.94 },
    { "Pb4+",  0.77 },
    { "Bi",    1.70 },
    { "Bi1+",  1.45 },
    { "Bi2+",  1.16 },
    { "Bi3+",  0.96 },
    { "Bi5+",  0.74 },
    { "Bi2-",  1.70 },
    { "Po",    1.70 },
    { "Po2+",  1.40 },
    { "Po4+",  1.10 },
    { "Po6+",  0.67 },
    { "At",    1.53 }, /* not in ICSD manual */
    { "At7+",  0.62 },
    { "Rn",    1.53 }, /* not in ICSD manual */
    { "Fr",    1.53 }, /* not in ICSD manual */
    { "Fr1+",  1.80 },
    { "Ra",    1.53 }, /* not in ICSD manual */
    { "Ra2+",  1.43 },
    { "Ac",    1.88 },
    { "Ac3+",  1.18 },
    { "Th",    1.80 },
    { "Th2+",  0.80 },
    { "Th3+",  0.90 },
    { "Th4+",  1.00 },
    { "Pa",    1.61 },
    { "Pa3+",  1.13 },
    { "Pa4+",  0.98 },
    { "Pa5+",  0.89 },
    { "U",     1.55 },
    { "U1+",   1.40 },
    { "U2+",   1.30 },
    { "U3+",   1.06 },
    { "U4+",   0.97 },
    { "U5+",   0.76 },
    { "U6+",   0.45 },
    { "Np",    1.58 },
    { "Np2+",  1.10 },
    { "Np3+",  1.04 },
    { "Np4+",  0.95 },
    { "Np5+",  0.80 },
    { "Np6+",  0.80 },
    { "Np7+",  0.71 },
    { "Pu",    1.64 },
    { "Pu2+",  0.90 },
    { "Pu3+",  1.00 },
    { "Pu4+",  0.80 },
    { "Pu5+",  0.70 },
    { "Pu6+",  0.60 },
    { "Am",    1.73 },
    { "Am2+",  1.20 },
    { "Am3+",  1.01 },
    { "Am4+",  0.92 },
    { "Am5+",  0.69 },
    { "Am6+",  0.50 },
    { "Cm",    1.42 }, /* was 0.00 in ICSD manual */
    { "Cm3+",  0.98 },
    { "Cm4+",  0.95 },
    { "Bk",    1.42 }, /* not in ICSD manual */
    { "Bk3+",  0.96 },
    { "Bk4+",  0.93 },
    { "Cf",    1.42 }, /* not in ICSD manual */
    { "Cf3+",  0.95 },
    { "Es",    1.42 }, /* not in ICSD manual */
    { "Fm",    1.42 }, /* not in ICSD manual */
    { "Md",    1.42 }, /* not in ICSD manual */
    { "No",    1.42 }, /* not in ICSD manual */
    { "Lr",    1.42 }, /* not in ICSD manual */
    { NULL,    0.   }
  };
#endif /* ATOMINFO_C__ */


typedef struct
  {
    const char  *Label;
    float       Length;
  }
  T_ChXrayWaveLength;


#ifndef ATOMINFO_C__
extern
const T_ChXrayWaveLength ListChXrayWaveLengths[];
#else
const T_ChXrayWaveLength ListChXrayWaveLengths[] =
  {
    { "CrA1", 2.28970 }, { "CrA2", 2.29361 }, { "Cr", 2.2909 },
    { "FeA1", 1.93604 }, { "FeA2", 1.93998 }, { "Fe", 1.9373 },
    { "CuA1", 1.54056 }, { "CuA2", 1.54439 }, { "Cu", 1.5418 },
    { "MoA1", 0.70930 }, { "MoA2", 0.71359 }, { "Mo", 0.7107 },
    { "AgA1", 0.55941 }, { "AgA2", 0.56380 }, { "Ag", 0.5608 },
    { NULL, 0. }
  };
#endif /* ATOMINFO_C__ */


/*  Neutron bound scattering lengths & cross-section

Data from: http://www.ncnr.nist.gov/resources/n-lengths/list.html

All of this data was taken from the Special Feature section of neutron
scattering lengths and cross sections of the elements and their isotopes in
Neutron News, Vol. 3, No. 3, 1992, pp. 29-37.
*/

typedef struct
  {
    const char  *Symbol;
    float       BondCohScattLength;
    float       BondCohScattLengthImag;
    float       AbsCrossSect;/* For 2200 m/s neutrons*/
  }
  T_NeutronBondSL_NN92;


#ifndef ATOMINFO_C__
extern
const T_NeutronBondSL_NN92 ListNeutronBondSL_NN92[];
#else
const T_NeutronBondSL_NN92 ListNeutronBondSL_NN92[] =
{
   {"H",        -3.7390,        0,      0.3326},
   {"D",        6.671,  0,      0.000519},
   {"He",       3.26,   0,      0.00747},
   {"Li",       -1.90,  0,      70.5},
   {"Be",       7.79,   0,      0.0076},
   {"B",        5.30,   -0.213, 767.},
   {"C",        6.6460, 0,      0.0035},
   {"N",        9.36,   0,      1.9},
   {"O",        5.803,  0,      0.00019},
   {"F",        5.654,  0,      0.0096},
   {"Ne",       4.566,  0,      0.039},
   {"Na",       3.63,   0,      0.53},
   {"Mg",       5.375,  0,      0.063},
   {"Al",       3.449,  0,      0.231},
   {"Si",       4.1491, 0,      0.171},
   {"P",        5.13,   0,      0.172},
   {"S",        2.847,  0,      0.53},
   {"Cl",       9.5770, 0,      33.5},
   {"Ar",       1.909,  0,      0.675},
   {"K",        3.67,   0,      2.1},
   {"Ca",       4.70,   0,      0.43},
   {"Sc",       12.29,  0,      27.5},
   {"Ti",       -3.438, 0,      6.09},
   {"V",        -0.3824,        0,      5.08},
   {"Cr",       3.635,  0,      3.05},
   {"Mn",       -3.73,  0,      13.3},
   {"Fe",       9.45,   0,      2.56},
   {"Co",       2.49,   0,      37.18},
   {"Ni",       10.3,   0,      4.49},
   {"Cu",       7.718,  0,      3.78},
   {"Zn",       5.680,  0,      1.11},
   {"Ga",       7.288,  0,      2.75},
   {"Ge",       8.185,  0,      2.2},
   {"As",       6.58,   0,      4.5},
   {"Se",       7.970,  0,      11.7},
   {"Br",       6.795,  0,      6.9},
   {"Kr",       7.81,   0,      25.},
   {"Rb",       7.09,   0,      0.38},
   {"Sr",       7.02,   0,      1.28},
   {"Y",        7.75,   0,      1.28},
   {"Zr",       7.16,   0,      0.185},
   {"Nb",       7.054,  0,      1.15},
   {"Mo",       6.715,  0,      2.48},
   {"Tc",       6.8,    0,      20.},
   {"Ru",       7.03,   0,      2.56},
   {"Rh",       5.88,   0,      144.8},
   {"Pd",       5.91,   0,      6.9},
   {"Ag",       5.922,  0,      63.3},
   {"Cd",       4.87,   -0.70,  2520.},
   {"In",       4.065,  -0.0539,        193.8},
   {"Sn",       6.225,  0,      0.626},
   {"Sb",       5.57,   0,      4.91},
   {"Te",       5.80,   0,      4.7},
   {"I",        5.28,   0,      6.15},
   {"Xe",       4.92,   0,      23.9},
   {"Cs",       5.42,   0,      29.0},
   {"Ba",       5.07,   0,      1.1},
   {"La",       8.24,   0,      8.97},
   {"Ce",       4.84,   0,      0.63},
   {"Pr",       4.58,   0,      11.5},
   {"Nd",       7.69,   0,      50.5},
   {"Pm",       12.6,   0,      168.4},
   {"Sm",       0.80,   -1.65,  5922.},
   {"Eu",       7.22,   -1.26,  4530.},
   {"Gd",       6.5,    -13.82, 49700.},
   {"Tb",       7.38,   0,      23.4},
   {"Dy",       16.9,   -0.276, 994.},
   {"Ho",       8.01,   0,      64.7},
   {"Er",       7.79,   0,      159.},
   {"Tm",       7.07,   0,      100.},
   {"Yb",       12.43,  0,      34.8},
   {"Lu",       7.21,   0,      74.},
   {"Hf",       7.7,    0,      104.1},
   {"Ta",       6.91,   0,      20.6},
   {"W",        4.86,   0,      18.3},
   {"Re",       9.2,    0,      89.7},
   {"Os",       10.7,   0,      16},
   {"Ir",       10.6,   0,      425.},
   {"Pt",       9.60,   0,      10.3},
   {"Au",       7.63,   0,      98.65},
   {"Hg",       12.692, 0,      372.3},
   {"Tl",       8.776,  0,      3.43},
   {"Pb",       9.405,  0,      0.171},
   {"Bi",       8.532,  0,      0.0338},
   {"Th",       10.31,  0,      7.37},
   {"U",        8.417,  0,      7.57},
   {NULL,0,0,0}
};
#endif /* ATOMINFO_C__ */


/*
  X-Ray anomalous scattering factors f' and f"
  Here: f = f0 f' + if"
  I.e. f' does not includes the f0 contribution at sin(theta)/lambda=0

->Henke tables 
  The data is extracted from the Henke tables, which can be found at:
    ftp://grace.lbl.gov/pub/sf/

  From ftp://grace.lbl.gov/pub/sf/read.me:

                Low-Energy X-ray Interaction Coefficients:
                Photoabsorption, Scattering, and Reflection
                        E = 30-30,000 eV, Z = 1-92

                B. L. Henke, E. M. Gullikson, and J. C. Davis
                        Center for X-Ray Optics, 2-400
                        Lawrence Berkeley Laboratory
                        Berkeley, California 94720

Reference : B. L. Henke, E. M. Gullikson, and J. C. Davis,
Atomic Data and Nuclear Data Tables Vol. 54 No. 2 (July 1993).

->Sasaki tables 
 scattering factors based on the Cromer and Liberman method.
 Original data can be downloaded from: 
 ftp://pfweis.kek.jp/pub/Sasaki-table/
 Any reports or publications of these data will acknowledge 
 its use by the citation:
   Anomalous scattering factors
        S.Sasaki (1989) Numerical Tables of Anomalous Scattering Factors
        Calculated by the Cromer and Liberman Method,
        KEK Report, 88-14, 1-136
 Questions about these data should be addressed to Dr.Satoshi Sasaki, 
 Tokyo Institute of Technology.  Email: sasaki@nc.titech.ac.jp
 

*/

typedef struct {
    float  Energy;
    float  f1;
    float  f2;
  }
  T_Ef1f2;

typedef struct {
    const char     *Symbol;
    const T_Ef1f2  *Ef1f2List;
  }
  T_Ef1f2_Henke;
  
typedef struct {
    const char     *Symbol;
    const T_Ef1f2  *Ef1f2List;
  }
  T_Ef1f2_Sasaki;


/* atominfo.c
 */
void AtomInfoStripLabel(const char *Label, int Exact, char *buf, int mbuf);
const T_PSE *FindInPSE(const char *Label, int Exact);
const T_SF_IT92_CAA *FindSF_IT92_CAA(const char *Label, int Exact);
double CalcSF_IT92_CAA(const T_SF_IT92_CAA *CAA, double stol2);
const T_SF_WK95_CAA *FindSF_WK95_CAA(const char *Label, int Exact);
double CalcSF_WK95_CAA(const T_SF_WK95_CAA *CAA, double stol2);
const T_AtomRadius *FindAtomRadius(const char *Label, int Exact);
const T_ChXrayWaveLength *ChXrayWaveLengthOf(const char *Label);
const T_NeutronBondSL_NN92 *FindNeutronBondSL_NN92(const char *Label,
                                                   int Exact);

/* henke.c
 */
const T_Ef1f2_Henke *FindEf1f2_Henke(const char *Label, int Exact);
void Get_fpfs_Henke(const char *Label, const float Energy,
                    float *fprime, float *fsecond);
/* sasaki.c
 */
const T_Ef1f2_Sasaki *FindEf1f2_Sasaki(const char *Label, int Exact);
void Get_fpfs_Sasaki(const char *Label, const float Energy,
                    float *fprime, float *fsecond);

#endif /* ATOMINFO_H__ */
